#!/bin/sh

dt=`date +%Y-%m-%dT%H:%M:%S`
pn=`basename $0`
pd=`dirname $0`
um="$USER@`uname -n`"

if [ ! -x $pd/BIN/wrapper.sh ]
then
    echo "$pn: Script $pd/BIN/wrapper.sh not found"
    exit 2
fi

if [ $# -ne 1 ]
then
    echo "$pn: Expected a single program name argument"
    exit 1
fi

if [ ! -x $pd/$1 ]
then
    echo "$pn: Program $pd/$1 not found"
    exit 1
fi

if [ ! -d $pd/LOG ]
then
    mkdir $pd/LOG
    chmod 777 $pd/LOG
fi

if [ ! -f $pd/LOG/$1 ]
then
    touch $pd/LOG/$1
    chmod 666 $pd/LOG/$1
fi

echo "log\t$dt\t$um" >> $pd/LOG/$1

ln $pd/$1 $pd/BIN/$1	# Hard link
ln -sf BIN/wrapper.sh $pd/$1

echo "Logging for $pd/$1 started"
