/* Copyright 1990-1992 Wind River Systems, Inc. */
/*
modification history
-------------------------
01a,30jun97,rjc added pragma align stuff
*/

#ifndef __INCp2typesh
#define __INCp2typesh

/******************************************
p2types.h:

copyright phase2 networks 1990
all rights reserved

common data types


SID: 1.7
Revision History:


    1.7	96/05/10 08:25:41 root
	make counter type always long

    1.6	95/09/25 16:58:57 root
	add timers

    1.5	95/07/10 10:30:54 root
	add sdword

    1.4	95/07/10 10:07:28 root
	common snmp.c

    1.3	94/02/25 16:27:29 root
	ifndef file for decnet coexistence

    1.2	93/04/15 16:48:09 root
	multi-prot enhancements

    1.1	92/05/29 12:34:05 jpp
	date and time created 92/05/29 12:34:05 by jpp

******************************************/
#ifndef _p2_types_h
#define _p2_types_h

#include <vxWorks.h>

#define boolean		int
#define enum_type 	int			
#define counter		unsigned long
#define gauge		unsigned long

#if 0
#define metric		int
#endif

/* above define creates compile problems in ifLib.h so  typedef below */
typedef int             metric;

typedef int		(*fcnptr)();
typedef void *		(*vfcnptr)();

#if ((CPU_FAMILY==I960) && (defined __GNUC__))
#pragma align 1                 /* tell gcc960 not to optimize alignments */
#endif  /* CPU_FAMILY==I960 */

/* generic dual linked list struct */
typedef struct dll{
	struct dll *dll_fwd;
	struct dll *dll_bwd;
}DLL, *dll_pt;

 
#ifndef dword
#define dword uint32_t
#endif
#ifndef word
#define word  uint16_t
#endif
#ifndef byte
#define byte  uint8_t
#endif

#ifndef sdword
#define sdword int32_t
#endif



#ifndef FALSE
#define FALSE 0
#endif
#ifndef TRUE
#define TRUE  1
#endif
#ifndef NULL
		#undef NULL
#define NULL  0
#endif

/* timer struct:
   we make an order linked list with expiration time
   to first entry kept separate. each entry then
   contains a delta time relative to previous.
*/
typedef struct phase2_timer{
	struct phase2_timer	*t_fwd; 	/* link */
	struct phase2_timer	*t_bwd; 	/* link */

					/* pointer to callback fnc to
					   call on expiration */
	void				*(*t_callback)();

					/* a pointer to a generic struct,
					   passed as param to callback */
	void				*t_param;
	int				 t_delta;	/* delta ttl */

					/* original time, used for cyclic
					   timers. */
	int				 t_time;
	int				 t_type;		/* cycle or 1shot */
}P2TIMER, *p2timer_pt;

#define TTYPE_ONESHOT	1
#define TTYPE_CYCLIC	2

/* timer list head */
typedef struct p2timer_head{
	p2timer_pt dll_fwd;
	p2timer_pt dll_bwd;
}P2THEAD, *p2thead_pt;

#if ((CPU_FAMILY==I960) && (defined __GNUC__))
#pragma align 0                 /* turn off alignment requirement */
#endif  /* CPU_FAMILY==I960 */

#endif /* _p2_types_h */

#endif /* __INCp2typesh */
