/* strmLib.h - Vxworks Streams header */

/* Copyright 1984-1995 Wind River Systems, Inc. */

/*
modification history
--------------------
01h,02jan96,sgv  changed return types to STATUS in declaration of strmDebugInit
01g,20oct95,jag  changed iosStrmInit to strmInit (SPR# 4956)
01f,07sep95,jag  Added defines for [SVR4 SVR3]_STYLE_OPEN, errnos, and included
		 sqlvl.h
01e,27aug95,sgv  Added prototypes for strmWeld and strmUnWeld
01d,27aug95,sgv  Added define S_strmLib_DUPLICATE_PROVIDER
01c,27aug95,jag  Added prototypes for strmSleep,strmWakeup, strmTimeout,
		 strmUntimeout, strmSyncWriteAccess. 
		 changed misysmac.h to sysmacros.h
01c,20aug95,sgv  changed streams include directories. Moved errnos to errno.h
01b,01aug95,dzb  Init prototypes.  Added strmSockLib.h inclusion.  cleanup.
01a,28jul95,sgv  written.
*/

#ifndef	__INCstrmLibh
#define	__INCstrmLibh

#ifdef __cplusplus
extern "C" {
#endif

#ifndef	WRS
#define	WRS
#endif	/* WRS */

/* includes */

#include "streams/stream.h"  /* Includes cred.h     */
#include "streams/stropts.h" /* Includes miioccom.h */
#include "streams/strstat.h"
#include "streams/strlog.h"
#include "streams/ddi.h"
#include "streams/sysmacros.h"
#include "streams/strmSockLib.h"
#include "streams/sqlvl.h"
#include "vwModNum.h"

/* defines used for strmDriverAdd and strmModuleAdd */

#define SVR3_STYLE_OPEN     1	/* STREAMS device uses SVR3 open parameters */
#define SVR4_STYLE_OPEN     0   /* STREAMS device uses SVR4 open parameters */

/* error number for strmLib.c */

#define S_strmLib_DUPLICATE_PROVIDER      	         (M_strmLib | 1)
#define S_strmLib_INVALID_OPEN_STYLE      	         (M_strmLib | 2)
#define S_strmLib_INVALID_SYNC_LEVEL      	         (M_strmLib | 3)

/* function declarations */

#if defined(__STDC__) || defined(__cplusplus)

extern STATUS strmWeld ( queue_t *pQdst1, queue_t *pQsrc1, queue_t *pQdst2, 
			 queue_t *pQsrc2, void (*pFunc)(), unsigned long arg0,
			 unsigned long arg1);
extern STATUS strmUnWeld ( queue_t *pQdst1, queue_t *pQdst2, 
			   void (*pFunc)(), unsigned long arg0,
			   unsigned long arg1);
extern int strmTimeout (void (*pFunc)(), caddr_t pArg, long ticks);
extern void strmUntimeout (int timeoutId);
extern int strmSleep (unsigned long event);
extern void strmWakeup (unsigned long event);
extern void strmSyncWriteAccess (queue_t *pQueue, mblk_t *pMsg, 
				 void (*pFuncToWrite)());
extern STATUS strmDriverAdd (char *pStrmDriverName,
			     struct streamtab *pStreamtab, int cloneFlag,
    			     struct streamtab *pBuddyStreamtab, int flags,
    			     int sqlvl);
extern STATUS strmModuleAdd (char *pModuleName, 
			     struct streamtab *pStreamtab,
			     struct streamtab *pBuddyStreamtab, int flags,
			     int sqlvl);

extern STATUS strmInit (unsigned strmMemSize, char *strmMemAddr,
    unsigned long strmMsgSize, unsigned long strmCtlSize, int strmPushMax);
extern STATUS strmSockInit (void);
extern STATUS tliInit (void);
extern STATUS autopushInit (void);
extern STATUS dlpiInit (void);
extern STATUS fattachInit (void);
extern STATUS strmStraceInit (char *pDefaultDir);
extern STATUS strmStrerrInit (char *pDefaultDir);
extern STATUS strmDebugInit (void);

#else	/* __STDC__ */

extern STATUS strmWeld ();
extern STATUS strmUnWeld ();
extern int strmTimeout ();
extern void strmUntimeout ();
extern int strmSleep ();
extern void strmWakeup ();
extern void strmSyncWriteAccess ();
extern STATUS strmDriverAdd ();
extern STATUS strmModuleAdd ();
extern STATUS strmInit ();
extern STATUS strmSockInit ();
extern STATUS tliInit ();
extern STATUS sadInit ();
extern STATUS dlpiInit ();
extern STATUS fattachInit ();
extern STATUS strmStraceInit ();
extern STATUS strmStrerrInit ();
extern STATUS strmDebugInit ();

#endif	/* __STDC__ */

#ifdef __cplusplus
}
#endif

#endif	/* __INCstrmLibh */
