/* _G_config.h - GNU general include file */

/* Copyright 1998 Wind River Systems, Inc. */

/*
modification history
--------------------
01e,19may98,sn  added CPU_FAMILY==SIMHPPA, SIMNT
01d,19may98,sn  added CPU_FAMILY==ARM
01c,01may98,sn  define _NO_LONG_DOUBLE_ and _NO_HYPOT_
01b,03mar98,sn  changed arch/.../_G_config.h to arch/.../_G_configArch.h
01a,03feb98,sn  created
*/

#include <vxWorks.h>
#define _NO_LONG_DOUBLE_
#define _NO_HYPOT_

#if (CPU_FAMILY==I80X86)
#include "arch/i86/_G_configArch.h"
#define __HAVE_G_CONFIG__
#endif

#if (CPU_FAMILY==I960)
#include "arch/i960/_G_configArch.h"
#define __HAVE_G_CONFIG__
#endif

#if (CPU_FAMILY==MC680X0)
#include "arch/mc68k/_G_configArch.h"
#define __HAVE_G_CONFIG__
#endif

#if (CPU_FAMILY==MIPS)
#include "arch/mips/_G_configArch.h"
#define __HAVE_G_CONFIG__
#endif

#if (CPU_FAMILY==PPC)
#include "arch/ppc/_G_configArch.h"
#define __HAVE_G_CONFIG__
#endif

#if (CPU_FAMILY==SIMSPARCSOLARIS)
#include "arch/simsolaris/_G_configArch.h"
#define __HAVE_G_CONFIG__
#endif

#if (CPU_FAMILY==SIMSPARCSUNOS)
#include "arch/simsparc/_G_configArch.h"
#define __HAVE_G_CONFIG__
#endif

#if (CPU_FAMILY==SPARC)
#include "arch/sparc/_G_configArch.h"
#define __HAVE_G_CONFIG__
#endif

#if (CPU_FAMILY==ARM)
#include "arch/arm/_G_configArch.h"
#define __HAVE_G_CONFIG__
#endif

#if (CPU_FAMILY==SIMHPPA)
#include "arch/simhppa/_G_configArch.h"
#define __HAVE_G_CONFIG__
#endif

#if (CPU_FAMILY==SIMNT)
#include "arch/simnt/_G_configArch.h"
#define __HAVE_G_CONFIG__
#endif

#ifndef __HAVE_G_CONFIG__
#error No _G_config.h has been generated for this CPU family.
#endif
