/* pentiumLib.h - system dependent routines header */

/* Copyright 1984-1998 Wind River Systems, Inc. */

/*
modification history
--------------------
01a,09jul97,hdn  written
*/

#ifndef __INCpentiumLibh
#define __INCpentiumLibh

#ifdef __cplusplus
extern "C" {
#endif

#ifndef	_ASMLANGUAGE

/* function declarations */

#if defined(__STDC__) || defined(__cplusplus)

extern int	pentiumCr4Get		(void);
extern void	pentiumCr4Set		(int cr4);
extern STATUS	pentiumPmcStart		(int pmcEvtSel0, int pmcEvtSel1);
extern void	pentiumPmcStop		(void);
extern void	pentiumPmcStop1		(void);
extern void	pentiumPmcGet		(long long int * pPmc0, 
					 long long int * pPmc1);
extern void	pentiumPmcGet0		(long long int * pPmc0);
extern void	pentiumPmcGet1		(long long int * pPmc1);
extern void	pentiumPmcReset		(void);
extern void	pentiumPmcReset0	(void);
extern void	pentiumPmcReset1	(void);
extern void	pentiumTscGet64		(long long int * pTsc);
extern UINT32	pentiumTscGet32		(void);
extern void	pentiumTscReset		(void);
extern void	pentiumMsrGet		(int addr, long long int * pData);
extern void	pentiumMsrSet		(int addr, long long int * pData);
extern void	pentiumTlbFlush		(void);
extern void	pentiumSerialize	(void);
extern STATUS	pentiumBts		(char * pFlag);
extern STATUS	pentiumBtc		(char * pFlag);
extern void	pentiumMtrrEnable	(void);
extern void	pentiumMtrrDisable	(void);
extern STATUS	pentiumMtrrGet		(MTRR * pMtrr);
extern STATUS	pentiumMtrrSet		(MTRR * pMtrr);
extern void	pentiumMcaShow		(void);
extern void	pentiumPmcShow		(BOOL zap);

#else	/* __STDC__ */

extern int	pentiumCr4Get		();
extern void	pentiumCr4Set		();
extern STATUS	pentiumPmcStart		();
extern void	pentiumPmcStop		();
extern void	pentiumPmcStop1		();
extern void	pentiumPmcGet		();
extern void	pentiumPmcGet0		();
extern void	pentiumPmcGet1		();
extern void	pentiumPmcReset		();
extern void	pentiumPmcReset0	();
extern void	pentiumPmcReset1	();
extern void	pentiumTscGet64		();
extern UINT32	pentiumTscGet32		();
extern void	pentiumTscReset		();
extern void	pentiumMsrGet		();
extern void	pentiumMsrSet		();
extern void	pentiumTlbFlush		();
extern void	pentiumSerialize	();
extern STATUS	pentiumBts		();
extern STATUS	pentiumBtc		();
extern void	pentiumMtrrEnable	();
extern void	pentiumMtrrDisable	();
extern STATUS	pentiumMtrrGet		();
extern STATUS	pentiumMtrrSet		();
extern void	pentiumMcaShow		();
extern void	pentiumPmcShow		();

#endif	/* __STDC__ */

#endif	/* _ASMLANGUAGE */

#ifdef __cplusplus
}
#endif

#endif /* __INCpentiumLibh */
