/* ioApic.h - Intel IO APIC (Advanced PIC) */

/* Copyright 1984 - 1998 Wind River Systems, Inc. */ 

/*
modification history
--------------------
01b,25may98,hdn re-written
01a,30jun97,sub written
*/

#ifndef __INCioApich
#define __INCioApich

#ifdef __cplusplus
extern "C" {
#endif


/* IO Apic register offset */

#define IOAPIC_DATA		0x10	/* IO window (data) */ 
#define IOAPIC_ID		0x00 	/* IOAPIC ID */
#define IOAPIC_VERS		0x01 	/* IOAPIC Version */
#define IOAPIC_ARB		0x02	/* IOAPIC Arbitration ID */
#define IOAPIC_REDTBL		0x10 	/* Redirection Table (24 * 64bit) */

/* redirection table entry number */

#define MAX_REDTABLE_ENTRIES	32

/* redirection table entry bits */

#define IOAPIC_INT_MASK		0x00010000
#define IOAPIC_LEVEL		0x00008000
#define IOAPIC_EDGE		0x00000000
#define IOAPIC_REMOTE		0x00004000
#define IOAPIC_LOW		0x00002000
#define IOAPIC_HIGH		0x00000000
#define IOAPIC_LOGICAL		0x00000800
#define IOAPIC_PHYSICAL		0x00000000
#define IOAPIC_FIXED		0x00000000
#define IOAPIC_LOWEST		0x00000100
#define IOAPIC_SMI		0x00000200
#define IOAPIC_NMI		0x00000400
#define IOAPIC_INIT		0x00000500
#define IOAPIC_EXTINT		0x00000700


#ifndef	_ASMLANGUAGE

/* redirection table structure */

typedef struct
    {
    UINT16 lsw;			/* lower 16 bit of the Redirection Table */
    UCHAR  vectorNo;		/* vector:  0x20 - 0xff */
    UCHAR  mask;		/* mask:    0 */
    } RED_TABLE;

#endif	/* _ASMLANGUAGE */

#ifdef __cplusplus
}
#endif

#endif /* __INCioApich */
