/* wPipeSio.h - header file for template serial driver */

/* Copyright 1984-1997 Wind River Systems, Inc. */

/*
modification history
--------------------
01b,05feb98,jmb added arg to dec'l of wPipeIntRcv.
01a,12sep97,cym written based on templateSio.h.
*/

#ifndef __INCwPipeSioh
#define __INCwPipeSioh

#include "sioLib.h"

/* device and channel structures */

typedef struct
    {
    /* must be first */

    SIO_CHAN		sio;		/* standard SIO_CHAN element */

    /* callbacks */

    STATUS	        (*getTxChar) ();
    STATUS	        (*putRcvChar) ();
    void *	        getTxArg;
    void *	        putRcvArg;

    /* register addresses */

    /* misc */

    int                 mode;           /* current mode (interrupt or poll) */
    int                 baudFreq;       /* input clock frequency */
    int			options;	/* Hardware options */
    int			transmitting;   /* used to mock transmit interrupts */
    int			pipe;
    int 		intVector;
    } WPIPE_CHAN;

/* function prototypes */

#if defined(__STDC__)

extern void 	wPipeDevInit	(WPIPE_CHAN *pChan); 
extern void	wPipeIntRcv	(WPIPE_CHAN *pChan, UINT16 wparam);
extern void	wPipeIntTx	(WPIPE_CHAN *pChan);
extern void	wPipeIntErr	(WPIPE_CHAN *pChan);

#else   /* __STDC__ */

extern void 	wPipeDevInit	();
extern void	wPipeIntRcv	();
extern void	wPipeIntTx	();
extern void	wPipeIntErr	();

#endif  /* __STDC__ */

#endif  /* __INCwPipeSioh */
