/* Copyright 1990-1992 Wind River Systems, Inc. */
/*
modification history
-------------------------
01a,30jun97,rjc added pragma align stuff
*/

#ifndef __INCos_consth
#define __INCos_consth

/*******************************************
os_const.h

OSPF constants

copyright phase2 networks inc, 1994
all rights reserved

SID: 1.5
Revision History:


    1.5	96/02/22 22:08:49 root
	move external constants here

    1.4	96/02/08 11:18:57 root
	add api constants

    1.3	96/02/06 22:29:33 root
	extern api mods

    1.2	95/10/05 15:34:26 root
	added error codes

    1.1	94/12/04 09:37:56 root
	date and time created 94/12/04 09:37:56 by root

**********************************************/
#ifndef OSPF_CONSTANTS_H
#define OSPF_CONSTANTS_H 1


#define LS_REFRESH		30*60
#define LS_MIN_INT		5
#define LS_MAXAGE		60*60
#define LS_CHECKAGE		5*60
#define LS_MAXAGEDIFF	15*60
#define LS_INFINITY		0x00ffffff
#define LSA_SEQ_START	0x80000001
#define LSA_SEQ_MAX		0x7fffffff
#define DEF_DEST		0			/* 0.0.0.0*/
#define OSPF_ALLSPF		224.0.0.5
#define OSPF_ALLDR		224.0.0.6
#define IP_PROT_OSPF	89

/* ospf error message codes -- the code for -1 must be there but the others 
 * may be anything.  */
#define OSPFERR_GENERAL_ERROR        -1  
#define OSPFERR_BAD_AUTH             -2  
#define OSPFERR_DUP                  -3  
#define OSPFERR_BAD_ALLOC            -4  
#define OSPFERR_ROUTER_ON            -5  
#define OSPFERR_NOT_FOUND            -6  
#define OSPFERR_BBAREA               -7  
#define OSPFERR_INTF_NOT_FOUND       -8  
#define OSPFERR_CONFLICT             -9  
#define OSPFERR_BAD_ADV             -10
#define OSPFERR_AREA_NOT_FOUND      -11
#define OSPFERR_UP                  -12
#define OSPFERR_NOCIRC		    -13
#define OSPFERR_BADVAL		    -14

#define OSPF_DEF_STUB_COST		1

/* the spec is for version 2, period.  But we may as well be flexible... */
#define CORRECT_OSPF_VERSION_NUMBER 2

#define ALL_D_ROUTERS 0xe0000006   /* 224.0.0.6 */
#define ALL_SPF_ROUTERS 0xe0000005 /* 224.0.0.5 */


/* external api modify constants */
#define OSPF_AM_ROUTERID		1
#define OSPF_AM_ASBDR_STATUS		2
#define OSPF_AM_IF_PRIORITY		3
#define OSPF_AM_IF_TRANSDEL		4
#define OSPF_AM_IF_RETRANSINT		5
#define OSPF_AM_IF_HELLOINT		6
#define OSPF_AM_IF_DEADINT		7
#define OSPF_AM_IF_POLLINT		8
#define OSPF_AM_IF_AUTHKEY		9
#define OSPF_AM_AR_AUTHTYPE		10
#define OSPF_AM_AR_IMPRTASE		11
#define OSPF_AM_AR_STUBMET		12
#define OSPF_AM_SPFHOLD			13
#define OSPF_AM_SPFSUSPEND		14
#define OSPF_AM_DOTOS			15
#define OSPF_AM_DOAUTOVLINK		16
#define OSPF_AM_IF_COST			17
#define OSPF_AM_IF_COSTDEL		18
#define OSPF_AM_IF_COSTTP		19
#define OSPF_AM_IF_COSTREL		20
#define OSPF_AM_IF_COSTMON		21

/* summary advertise */
#define R_ADVERTISE		1
#define R_NO_ADVERTISE	2

/* auth types */
#define AUTH_TYPE_NONE 0
#define AUTH_TYPE_SIMPLE 1

/* circuit types */
#define CIRC_ETH        1       /* ETHERNET TYPE */
#define CIRC_TR         2       /* tkn rng- functional */
#define CIRC_TRGRP      4       /* tkn rng- group address */
#define CIRC_FDDI       8
#define CIRC_LEM        0x80        /* lan emulate (nbma) */
#define CIRC_LAN        0xff    /* any lan */

#define CIRC_PTPT       0x100   /* leased line or direct */
#define CIRC_VLNK       0x200   /* virtual link */


#endif /* #define OSPF_CONSTANTS_H */
#endif /* __INCos_consth */
