/* Copyright 1990-1992 Wind River Systems, Inc. */
/*
modification history
-------------------------
01a,30jun97,rjc added pragma align stuff
*/

#ifndef __INCos_dbph
#define __INCos_dbph

/**********************************************
os_dbp.h

OSPF database exchange request packet definition

copyright phase2 networks inc, 1994
all rights reserved

SID: 1.1
Revision History:


    1.1	94/12/04 09:37:59 root
	date and time created 94/12/04 09:37:59 by root

**********************************************/
#ifndef OSPF_DBPACKET_H 
#define OSPF_DBPACKET_H  1

#define REQUEST_FAILURE -1
#define REQUEST_SUCCESS 0

#define IS_MAX_AGE(age) ( (age)==LS_MAXAGE)

#define COPY_LSA_HDR(dest,src) memcpy((void*)dest,(void*)src,LSA_HEADER_SIZE)
#define COPY_LSA(dest,src,size) memcpy((void*)dest,(void*)src,size)

#define INCR_CURLSA(lsa,size) ( lsa = (LSA*)( (byte*)(lsa) + (size)))
#define INCR_LSA_HDR(lsa) ( INCR_CURLSA(lsa, LSA_HEADER_SIZE))

#if ((CPU_FAMILY==I960) && (defined __GNUC__))
#pragma align 1                 /* tell gcc960 not to optimize alignments */
#endif  /* CPU_FAMILY==I960 */

typedef struct db_req_node {
  struct db_req_node * dbreq_fwd;
  struct db_req_node * dbreq_bwd;
  struct lsr dbr_lsr;
} db_req, *db_req_pt;

#if ((CPU_FAMILY==I960) && (defined __GNUC__))
#pragma align 0                 /* turn off alignment requirement */
#endif  /* CPU_FAMILY==I960 */

#endif /* OSPF_DBPACKET_H  */
#endif /* __INCos_dbph */
