/* Copyright 1990-1992 Wind River Systems, Inc. */
/*
modification history
-------------------------
01a,30jun97,rjc added pragma align stuff
*/

#ifndef __INCos_recvh
#define __INCos_recvh

/**********************************************
os_recv.h

OSPF received packet processing related 
definitions

copyright phase2 networks inc, 1994
all rights reserved

SID: 1.2
Revision History:


    1.2	96/02/06 22:30:24 root
	extern api mods

    1.1	94/12/04 09:38:36 root
	date and time created 94/12/04 09:38:36 by root

***********************************************/
#ifndef OSPF_RECV_H
#define OSPF_RECV_H


#ifndef Error
#define Error -1
#endif

#define CHECKSUM_OK TRUE

/* The types of OSPF protocol packets */
#define OSPF_HELLO_PACKET 1
#define OSPF_DB_DESC_PACKET 2
#define OSPF_LS_REQ_PACKET 3
#define OSPF_LS_UPDATE_PACKET 4
#define OSPF_LS_ACK_PACKET 5

/* Found/NotFound, returned by SearchHelloPacket */
#define Found 1
#define NotFound 0

/* Need a zero address for comparison with that in packet.
   Just a plain zero should do...
 */
#define ZERO_ADDRESS ( (dword) 0)

#define SAME_NETWORK(s,d,m) ( ((s)&(m)) == ((d)&(m)))
#endif

#endif /* __INCos_recvh */
