/* Copyright 1990-1992 Wind River Systems, Inc. */
/*
modification history
-------------------------
01a,30jun97,rjc added pragma align stuff
*/

#ifndef __INCp2btreeh
#define __INCp2btreeh

/****************************************
p2btree.h

common binary tree definitions

copyright phase2 networks 1996
all rights reserved


SID: 1.1
Revision History:


    1.1	96/03/01 14:29:19 root
	date and time created 96/03/01 14:29:19 by root

*****************************************/

#if ((CPU_FAMILY==I960) && (defined __GNUC__))
#pragma align 1                 /* tell gcc960 not to optimize alignments */
#endif  /* CPU_FAMILY==I960 */

typedef struct p2BalTree{
	struct p2BalTree	*b_bwd;
	struct p2BalTree	*b_left;
	struct p2BalTree	*b_right;
	int				 b_bal;
}p2btree,*p2btree_pt;

#if ((CPU_FAMILY==I960) && (defined __GNUC__))
#pragma align 0                 /* turn off alignment requirement */
#endif  /* CPU_FAMILY==I960 */

fnc_prot(int, p2BtreeInsert,(p2btree *,p2btree **, int (*)()))
fnc_prot(void, p2BtreeDelete,(p2btree *,p2btree **))
fnc_prot(p2btree,  *p2BtreeNext,(p2btree *))
fnc_prot(p2btree,  *p2BtreeFirst,(p2btree **))

#endif /* __INCp2btreeh */
