/* Copyright 1990-1992 Wind River Systems, Inc. */
/*
modification history
-------------------------
01a,30jun97,rjc added pragma align stuff
*/

#ifndef __INCp2cfgh
#define __INCp2cfgh

/******************************************
p2cfg.h:

copyright phase2 networks 1996
all rights reserved

configuration block definition.
used to restore saved parameters on reboot.


SID: 1.1
Revision History:


    1.1	96/06/19 08:36:56 root
	date and time created 96/06/19 08:36:56 by root

******************************************/

#if ((CPU_FAMILY==I960) && (defined __GNUC__))
#pragma align 1                 /* tell gcc960 not to optimize alignments */
#endif  /* CPU_FAMILY==I960 */

typedef struct p2config_blk{
	unsigned char	prot_id;	/* protocol entity */
	unsigned char	type;		/* block type in protocol */
	unsigned short	len;		/* len of blk including 
					   this header */
}p2cfg;

#if ((CPU_FAMILY==I960) && (defined __GNUC__))
#pragma align 0                 /* turn off alignment requirement */
#endif  /* CPU_FAMILY==I960 */

/* configurable protocol types */
#define P2CFG_IP	1
#define P2CFG_OSPF	2
#define P2CFG_IPX	3
#define P2CFG_NLSP	4
#define P2CFG_ATALK	5
#define P2CFG_DECNET	6
#define P2CFG_OSI	7
#define P2CFG_BGP	8
#define P2CFG_IPV6	9

#endif /* __INCp2cfgh */
