/** Copyright (c) 1993, 1994  Mentat Inc.
 ** milocks.h 4.1, last change 4/14/94
 **/

/* Copyright 1984-1995 Wind River Systems, Inc. */

/*
modification history
01a,24mar97,sgv  mps_intr_disable defined to intLock, mps_intr_enable defined
		 to intUnlock()
*/

#ifndef __INCmilocksh
#define __INCmilocksh

#ifndef _MILOCKS_
#define _MILOCKS_

#ifndef WRS
#ifndef lint
static	char	milocks_h_sccsid[] = "@(#)milocks.h 4.1";
#endif
#endif /* WRS */

typedef	volatile int	MPSLF, * MPSLFP;

typedef	int		MPS_INTR_STATE;

#ifndef OTHER_MPS_LOCK_TYPE  /* NCF - Added since MPS didn't have it! */

#if ((CPU_FAMILY==I960) && (defined __GNUC__))
#pragma align 1                 /* tell gcc960 not to optimize alignments */
#endif  /* CPU_FAMILY==I960 */

typedef	struct mpsl_s {
	MPSLF		mpsl_lockf;
	MPS_INTR_STATE	mpsl_intr_state;
} MPSL, * MPSLP;

#if ((CPU_FAMILY==I960) && (defined __GNUC__))
#pragma align 0                 /* turn off alignment requirement */
#endif  /* CPU_FAMILY==I960 */

#define mps_intr_disable(intr_statep)	(*(intr_statep) = intLock())
#define mps_intr_enable(intr_statep)	intUnlock(*(intr_statep))

#else
 /* If we have a different type, we'd better have different functions! */
#define OTHER_MPS_LOCK_ACQUIRE 1
#define OTHER_MPS_LOCK_ALLOC   1
#define OTHER_MPS_LOCK_RELEASE 1

#endif /* OTHER_MPS_LOCK_TYPE */

#define	become_writer(q, mp, func)	func(q,mp)

#ifndef OTHER_MPS_LOCKF_ACQUIRE
#define	mps_lockf_acquire(mpslf)     \
	( (*(mpslf)) ? 0						\
	: ((((unsigned char *)(mpslf))[0] = 1), ((unsigned char *)(mpslf))[1] ? 0 \
	: ((((unsigned char *)(mpslf))[1] = 1), ((unsigned char *)(mpslf))[2] ? 0 \
	: ((*(mpslf) = ~0), 1))) )

#define	mps_lockf_release(mpslf)					     \
	do { *(mpslf) = 0; /*STBAR;*/ } while (0)

#define mps_lockf_alloc(mpslf)		(*(mpslf)=0,true)

#define mps_lockf_free(mpslf)

#define mps_lockf_in_use(mpslf)		(*(mpslf))
#endif	/** OTHER_MPS_LOCKF_ACQUIRE */

#ifndef OTHER_MPS_LOCK_ACQUIRE
extern	void	mps_lock_acquire(   MPSLP mpsl   );
#endif

#ifndef OTHER_MPS_LOCK_ALLOC
extern	int	mps_lock_alloc(   MPSLP mpsl   );
#endif

#ifndef OTHER_MPS_LOCK_RELEASE
extern	void	mps_lock_release(   MPSLP mpsl   );
#endif

#endif	/* _MILOCKS_ */

#endif /* __INCmilocks */
