#ifndef __INCmpsalloch
#define __INCmpsalloch

/** Copyright (c) 1993-1994  Mentat Inc.
 ** mpsalloc.h 4.1, last change 4/25/94
 **/

#ifndef	_MPSALLOC_
#define	_MPSALLOC_

/*
 * Define CHECK_DUAL_FREE (here or in led.h) to compile in runtime checking
 * for double freeing of mblks.  This currently requires an extra conditional
 * in the main path, so it is left as a compile time option for now.
 */
/* #define CHECK_DUAL_FREE */

#define	NSTREVENT	20		/** size of bufcall heap */

#define	LARGEST_BUCKET_SIZE	8192

#define	BUCKET_COUNT	8
#define	BUCKET_SELECT_OR_RETURN(p,s,e) \
	do { \
		unsigned int	_s = (unsigned int)(s); \
		if (_s > 512) { \
			_s += 15; \
			_s >>= 4; \
			p += 4; \
			if (_s > (LARGEST_BUCKET_SIZE >> 4)) { return e; } \
		} \
		if (_s > 128) { \
			_s += 3; \
			_s >>= 2; \
			p += 2; \
		} \
		_s += 63; \
		_s >>= 7; \
		p += _s; \
	} while (0)

#if ((CPU_FAMILY==I960) && (defined __GNUC__))
#pragma align 1                 /* tell gcc960 not to optimize  alignments */
#endif  /* CPU_FAMILY==I960 */

/* Bufcall callback structure */
typedef struct bc_s {
	struct bc_s * bc_next;	/* Either next free or next allocated entry */
	struct bc_s ** bc_ptpn;	/* ptpn == Pointer to previous 'next' field */
	int	bc_id;		/* 'id' we passed back bufcall() caller */
	void	(*bc_pfv)(long arg);	/* callback function supplied to bufcall() */
	long	bc_arg;		/* arg supplied to bufcall() */
	int	bc_hq_index;
#ifdef MPS_HEAP_BC_XTRA
	MPS_HEAP_BC_XTRA
#endif
} bc_t;

/*
 * List head/tail structure for bufcall entries.
 * We use one per bucket size.
 */
typedef struct bcd_s {
	struct bc_s	* bcd_head;
	struct bc_s	* bcd_tail;
} bcd_t;

typedef struct dblkx_s {
	dblk_t	dblkx_dblk;
	unsigned int dblkx_flags;
} dblkx_t;

#define	DB_FLAGS(db)	(((dblkx_t *)db)->dblkx_flags)

#define	DBLK_ALLOC_XTRA	(ALIGNED_DBLK_T_SIZE + MPS_HCHECK_TRAILER_LENGTH)

/* Change F_DB_INDEX_MASK as needed to accomodate your hq_arr[] size */
#define	F_DB_INDEX_MASK		0xF	/* Must be a power of 2 - 1 */
#define	F_DB_CALLBACK		((F_DB_INDEX_MASK + 1))
#define	F_DB_DUPED		((F_DB_INDEX_MASK + 1) << 1)
#define	F_DB_FREE_ON_2		((F_DB_INDEX_MASK + 1) << 2)
#define	F_DB_HEAP_CHECK		((F_DB_INDEX_MASK + 1) << 3)
#define	F_DB_FREE_TO_HEAP	((F_DB_INDEX_MASK + 1) << 4)
#define	F_DB_MP_FLAG1		((F_DB_INDEX_MASK + 1) << 5)
#define	F_DB_MP_FLAG2		((F_DB_INDEX_MASK + 1) << 6)
#define	F_DB_CPU0		((F_DB_INDEX_MASK + 1) << 7)
#define	F_DB_SHOULD_NOT_BE_FREED ((F_DB_INDEX_MASK + 1) << 8)

#define	F_DB_HARD_STUFF_MASK \
 (F_DB_CALLBACK | F_DB_DUPED | F_DB_FREE_ON_2 | \
  F_DB_HEAP_CHECK | F_DB_FREE_TO_HEAP | F_MP_ON_FREE_LIST | \
  F_DB_SHOULD_NOT_BE_FREED)

#ifndef	ALLOCB_ALIGNMENT_SIZE
#define	ALLOCB_ALIGNMENT_SIZE	16
#endif

#define	ROUNDUP(x,y)	(((x) + (y - 1)) & ~(y - 1))

	/* The compiler should see this as a constant, one way or the other */
#define	ZERO_BAND_AND_FLAG(mp) \
	do { \
	if (OK_32PTR(offsetof(mblk_t, b_band)) \
	&& (offsetof(mblk_t, b_band) + sizeof_fld(mblk_t, b_band)  \
		== offsetof(mblk_t, b_pad1)) \
	&& (offsetof(mblk_t, b_pad1) + sizeof_fld(mblk_t, b_pad1) \
		== offsetof(mblk_t, b_flag)) \
	&& (sizeof_fld(mblk_t, b_band) + sizeof_fld(mblk_t, b_pad1) \
		+ sizeof_fld(mblk_t, b_flag)) == sizeof(unsigned int)) { \
		*((unsigned int *)&(mp)->b_band) = 0; \
	} else { \
		(mp)->b_band = 0; \
		(mp)->b_flag = 0; \
	} \
	} while (0)

#define	MP_FLAGS(mp)		0
#define	MP_FLAGS_ADD(mp,v)	/* */
#define	MP_FLAGS_SET(mp,v)	/* */
#define	F_MP_ON_FREE_LIST	0
#define	F_MP_MARKED		0

#define	MPS_HEAP_ALLOC_PATTERN			'A'
#define	MPS_HEAP_FREE_PATTERN			'D'

#ifdef MPS_HCHECK_DISABLED

#define	HEAP_CHECK_ON(heap)		(0)
#define	MPS_HCHECK_TRAILER_LENGTH	0
#define	MPS_HCHECK_HEADER_LENGTH	0
#define	MPS_HCHECK_BIAS_TO_AVAILABLE	0
#undef	F_DB_HEAP_CHECK
#define	F_DB_HEAP_CHECK			0

#define	mps_comefrom(a)		/* */

#else

#ifdef CHECK_DUAL_FREE
#undef	MP_FLAGS
#undef	MP_FLAGS_ADD
#undef	MP_FLAGS_SET
#undef	F_MP_ON_FREE_LIST
#undef	F_MP_MARKED
#define	MP_FLAGS(mp)		((mblkx_t *)mp)->bx_flags
#define	MP_FLAGS_ADD(mp,v)	do { int _f = MP_FLAGS(mp) | (v); MP_FLAGS(mp) = _f; } while (0)
#define	MP_FLAGS_SET(mp,v)	do { MP_FLAGS(mp) = (v); } while (0)
#define	F_MP_ON_FREE_LIST	F_DB_MP_FLAG1
#define	F_MP_MARKED		F_DB_MP_FLAG2
#endif

#define	HEAP_CHECK_ON(heap)		((heap)->heap_check_on)
#define	MPS_HCHECK_TRAILER_LENGTH	sizeof(check_t)
#define	MPS_HCHECK_HEADER_LENGTH	sizeof(check_t)
#define	MPS_HCHECK_BIAS_TO_AVAILABLE	(MAXLONG/2)

#endif

#ifndef OTHER_MPS_LOCK_TYPE
#define	MPS_HEAP_DBG_CHK(cmd)						\
	do {								\
	if ( !mps_lockf_in_use(&mps_heap.heap_mpsl.mpsl_lockf) ) {	\
		cmd;							\
		printf("[OK]\n");					\
	}								\
	} while (0)

#else
        /* This version added for VxWorks - NCF */
#define	MPS_HEAP_DBG_CHK(cmd)	\
	do {								\
	if ( !mps_lock_in_use(&mps_heap.heap_mpsl) ) {	\
		cmd;							\
		printf("[OK]\n");					\
		mps_lock_release(&mps_heap.heap_mpsl);                  \
	}								\
	} while (0)

#endif

#define	ALIGNED_DBLK_T_SIZE \
 ROUNDUP((sizeof(dblkx_t) + MPS_HCHECK_HEADER_LENGTH), ALLOCB_ALIGNMENT_SIZE)

typedef unsigned long	check_t;

/* Try to coax the compiler into better alignment */
typedef union mpsla_u {
	MPSL	mpsla_mpsl;
	double	mpsla_double;
} MPSLA;

/* The heap queue struct that is touched on every allocb() and freeb() */
typedef struct hq_s {
 /* Negative means we are heap checking and/or we have bufcalls waiting */
	long	hq_available;
	mblk_t	* hq_next;	/* Next available mblk */
} hq_t;

/* The non time/cache critical parts of each heap bucket */
typedef struct hqx_s {
	unsigned long	hqx_size;	/* Data size in this bucket */
	unsigned long	hqx_total;	/* Total number of this size */
	unsigned long	hqx_failures;	/* # of allocate failures  */
	unsigned long	hqx_kmem_in_use;
} hqx_t;

/* Indexes into hqx or hq arrays */
#define	DUP_INDEX		0
#define	SMALLEST_BUCKET_INDEX	1
#define	LARGE_BUCKET_INDEX	(SMALLEST_BUCKET_INDEX + BUCKET_COUNT)

typedef struct heap_s {
	MPSLA	heap_mpsla;
#define	heap_mpsl		heap_mpsla.mpsla_mpsl
	hq_t	heap_hq[BUCKET_COUNT + 1];
	hqx_t	heap_hqx[BUCKET_COUNT + 2];
	check_t	heap_alloc_pattern;
	check_t heap_free_pattern;
	struct mblkx_s * heap_head;	/* Head of all extant mblks */
	/* 
	 * NOTE: using an extendable heap_bc array would be easy but we 
	 * probably would not find enough memory to extend that array 
	 * at bufcall() time.
	 */
	bc_t	* heap_bc_free_list;
	bc_t	* heap_bc_next_uninitialized;
	/* We mimic heap_hq[] here, using [DUP_INDEX] as a guard
	** against calls by freeb() to bufcall_check_one_size()
	** when dupb()ed mblks are freed and available is negative.
	** This happens when we are heap checking.
	*/
	bcd_t	heap_bcd[BUCKET_COUNT + 1];
	bc_t	heap_bc[NSTREVENT];
	int	heap_max_mblk;		/* Max alloc'd mblks previously. */
#ifndef MPS_HCHECK_DISABLED
	boolean	heap_check_on;
#endif
} heap_t;

typedef struct mblkx_s {
	mblk_t	bx_mblk;
	SQE	bx_sqe;
	unsigned int	bx_flags;
	struct mblkx_s	* bx_next;	/* Complete alloc list */
	struct mblkx_s	** bx_ptpn;
#ifndef	MPS_HCHECK_DISABLED
	void	* bx_alloc_comefrom[4];
	void	* bx_free_comefrom[4];
#endif
} mblkx_t;

#if ((CPU_FAMILY==I960) && (defined __GNUC__))
#pragma align 0                 /* turn off alignment requirement */
#endif  /* CPU_FAMILY==I960 */

#endif	/* _MPSALLOC_ WRS fix ANSI compatability problem */

#endif /* __INCmpsalloch */
