/* sockio.h - Socket I/O header */

/* Copyright 1984-1995 Wind River Systems, Inc. */

/*
modification history
--------------------
01a,24aug95,sgv  Added copyright
*/

/** Copyright (c) 1992  Mentat Inc.
 ** sockio.h 4.1, last change 4/30/94
 **/
#ifndef _SOCKIO_
#define _SOCKIO_

#ifndef WRS
static	char	sockio_h_sccsid[] = "@(#)sockio.h	4.1";
#endif

#ifdef __cplusplus
extern "C" {
#endif

#ifndef MIOC_CMD
#include <miioccom.h>
#endif

#ifdef	_IOR
#undef	_IO
#undef	_IOR
#undef	_IOW
#undef	_IOWR
#endif

#define	_IO(x,y)	MIOC_CMD(MIOC_SIOC,y)
#define	_IOR(x,y,t)	MIOC_CMD(MIOC_SIOC,y)
#define	_IOW(x,y,t)	MIOC_CMD(MIOC_SIOC,y)
#define	_IOWR(x,y,t)	MIOC_CMD(MIOC_SIOC,y)

#define	SIOCSHIWAT	_IOW(s,  0, int)		/* set high watermark */
#define	SIOCGHIWAT	_IOR(s,  1, int)		/* get high watermark */
#define	SIOCSLOWAT	_IOW(s,  2, int)		/* set low watermark */
#define	SIOCGLOWAT	_IOR(s,  3, int)		/* get low watermark */
#define	SIOCATMARK	_IOR(s,  7, int)		/* at oob mark? */
#define	SIOCSPGRP	_IOW(s,  8, int)		/* set process group */
#define	SIOCGPGRP	_IOR(s,  9, int)		/* get process group */

#define	SIOCADDRT	_IOW(r, 10, struct rtentry)	/* add route */
#define	SIOCDELRT	_IOW(r, 11, struct rtentry)	/* delete route */
#define	SIOCFLUSHRT	_IO(r, 55)			/* flush all routes */

#define	SIOCSIFADDR	_IOW(i, 12, struct ifreq)	/* set ifnet address */
#define	SIOCGIFADDR	_IOWR(i,13, struct ifreq)	/* get ifnet address */
#define	SIOCSIFDSTADDR	_IOW(i, 14, struct ifreq)	/* set p-p address */
#define	SIOCGIFDSTADDR	_IOWR(i,15, struct ifreq)	/* get p-p address */
#define	SIOCSIFFLAGS	_IOW(i, 16, struct ifreq)	/* set ifnet flags */
#define	SIOCGIFFLAGS	_IOWR(i,17, struct ifreq)	/* get ifnet flags */
#define	SIOCSIFMEM	_IOW(i, 18, struct ifreq)	/* set interface mem */
#define	SIOCGIFMEM	_IOWR(i,19, struct ifreq)	/* get interface mem */
#define	SIOCGIFCONF	_IOWR(i,20, struct ifconf)	/* get ifnet list */
#define	SIOCSIFMTU	_IOW(i, 21, struct ifreq)	/* set if_mtu */
#define	SIOCGIFMTU	_IOWR(i,22, struct ifreq)	/* get if_mtu */

#define	SIOCGIFBRDADDR	_IOWR(i,23, struct ifreq)	/* get broadcast addr */
#define	SIOCSIFBRDADDR	_IOW(i,24, struct ifreq)	/* set broadcast addr */
#define	SIOCGIFNETMASK	_IOWR(i,25, struct ifreq)	/* get net addr mask */
#define	SIOCSIFNETMASK	_IOW(i,26, struct ifreq)	/* set net addr mask */
#define	SIOCGIFMETRIC	_IOWR(i,27, struct ifreq)	/* get IF metric */
#define	SIOCSIFMETRIC	_IOW(i,28, struct ifreq)	/* set IF metric */

#define	SIOCSARP	_IOW(i, 30, struct arpreq)	/* set arp entry */
#define	SIOCGARP	_IOWR(i,31, struct arpreq)	/* get arp entry */
#define	SIOCDARP	_IOW(i, 32, struct arpreq)	/* delete arp entry */

#define	SIOCADDMULTI	_IOW(i, 49, struct ifreq)	/* set m/c address */
#define	SIOCDELMULTI	_IOW(i, 50, struct ifreq)	/* clr m/c address */

#define	IF_UNITSEL	_IOW(i, 54, int)		/* set unit number */

#ifdef __cplusplus
}
#endif

#endif	/* _SOCKIO_	*/
