/* Copyright 1995 Wind River Systems, Inc. */

/*
modification history
--------------------
01b,20aug95,jag  set MI_HDRS defined to true
*/

#ifndef __INCsockmodh
#define __INCsockmodh

#ifndef _SOCKMOD_
#define _SOCKMOD_
#ifndef MI_HDRS
#define MI_HDRS
#endif  /* MI_HDRS */

#ifndef WRS
static char	sockmod_h_sccsid[] = "@(#)sockmod.h	4.1 gh'd from sockmod.c";
#endif

/** Copyright (c) 1993  Mentat Inc.
 ** sockmod.c 4.4, last change 12/14/93
 **/

#ifdef __cplusplus
extern "C" {
#endif

#ifdef MI_HDRS
#ifndef _SOCKUSER_
#include <sockuser.h>
#endif
#ifndef _MIIOCCOM_
#include <miioccom.h>
#endif

#else
#ifndef _SOCKUSER_
#include <inet/sockuser.h>
#endif
#ifndef _MIIOCCOM_
#include <inet/miioccom.h>
#endif
#endif

/**
 ** sockmod ioctl's
 **/
#define SSO_ACCEPT		MIOC_CMD(MIOC_SOCKETS, 1)
#define	SSO_BIND		MIOC_CMD(MIOC_SOCKETS, 2)
#define	SSO_CONNECT		MIOC_CMD(MIOC_SOCKETS, 3)
#define	SSO_LISTEN		MIOC_CMD(MIOC_SOCKETS, 4)
#define	SSO_SENDTO		MIOC_CMD(MIOC_SOCKETS, 5)
#define	SSO_GETNAME		MIOC_CMD(MIOC_SOCKETS, 6)
#define	SSO_INFO		MIOC_CMD(MIOC_SOCKETS, 7)
#define	SSO_OPTMGMT		MIOC_CMD(MIOC_SOCKETS, 8)
#define SSO_SETERR		MIOC_CMD(MIOC_SOCKETS, 9)
#define	SSO_SOCKET		MIOC_CMD(MIOC_SOCKETS, 10)
#define	SSO_UNBIND		MIOC_CMD(MIOC_SOCKETS, 11)

#define	SSO_GETOOB		MIOC_CMD(MIOC_SOCKETS, 13)
#define	SSO_PEEKOOB		MIOC_CMD(MIOC_SOCKETS, 14)
#define SSO_SHUTDOWN		MIOC_CMD(MIOC_SOCKETS, 15)
#define SSO_ATMARK		MIOC_CMD(MIOC_SOCKETS, 16)

/**
 ** sockmod special TPI messages.  These are sent as M_PCPROTO from library
 ** to sockmod; these defines chosen to have no conflict with other valid
 ** TPI usage of these primitives.
 **/
#define	SO_BLOCK_REQ	T_ORDREL_IND	/** cross min/maxpsz to force ERANGE */

/**
 ** sockmod states
 **/
#define SS_UNINIT	0
#define SS_UNBND	1
#define SS_USRBNDREQ	2
#define SS_LSNBNDREQ	3
#define SS_MODBNDREQ	4
#define SS_BND		5
#define SS_CONNREQ	6

#define SS_CONN		8
#define SS_ACCREQ       9
#define SS_DISREQ	10

#define SS_TUBED	99

#define NAMELEN		FMNAMESZ + 6
#define COPYIN_SIZE	512		/** buffer size for sendto ioctl... */

/*
 * following dimension of local char arrays.  It must be large enough
 * for each structure appearing in MAX
 */
#define STACK_BUF_SIZE	MAX(512, sizeof(SINFO))

#if ((CPU_FAMILY==I960) && (defined __GNUC__))
#pragma align 1                 /* tell gcc960 not to optimize alignments */
#endif  /* CPU_FAMILY==I960 */

/** Special socklib/mod ACK returning socket info. */
struct T_conn_ack {
	struct T_ok_ack	toa;		/* TPI OK_ACK */
	int		CONNECT_type;	/* connection mode (STREAM or DGRAM) */
		/* for this socket */
};

/** Modified T_UNITDATA_REQ. **/
struct T_sendto_req {
	struct T_unitdata_req	tur;	/*  TPI defined structure... */
	long		DATA_length;
	unsigned char	* DATA_ptr;	/* if nil, data at offset + length */
};

/** Sockmod private data structure. */
typedef struct sockinfo {
	int	si_domain;	/* SOCKET domain (address family)*/
	int	si_type;	/* SOCKET type, stream, datagram, raw, ... */
	int	si_proto;	/* SOCKET protocol */
	int	si_state;	/* SOCKET state (idle, bound, ...) */
	int	si_errno;	/* GETSOCKOPT(fd, SO_ERROR, *arg) */
	int	si_tlierr;	/* TLI_error (if any) for si_errno */
	int	si_bound;	/* bound state before current state */
				/* (for error reset) */
	int	si_backlog;	/* backlog for listen in TPI bind */
	int	si_lostioc;	/* count of unanswered IOCTL msg's */
	int	si_local_size;	/* address size of local */
	int	si_remote_size;	/* address size of remote */
	int	si_mdata_count;	/* # of M_DATA msgs processed debug)*/
	int	si_putq_count;	/* # of queued msgs (debug) */
	int	si_sodebug;	/* SO_DEBUG value */
	int	si_special_flag;/* non-zero if M_DATA triggers event */
#define READ_SHUT	0x01
#define	WRITE_SHUT	0x02
#define DISCON_SHUT	0x04
#define MARK_AT_END	0x08

	SADDR		si_local;	/* SOCKET address of local node */
	SADDR		si_remote;	/* SOCKET address of remote node */
	struct T_info_ack si_tinfo;	/* data returned from TPI T_INFO_REQ */

#ifdef KERNEL	/**/
	mblk_t		* si_saved_ioc;	/* Current IOCTL block from head. */
	mblk_t		* si_saved_arg;	/* "arg" block for ioctl() */
	queue_t		* si_sockmod_wrq; /* our write q */
	long		si_copyout;	/* # of copyout msg's already seen */
	long		si_lastmark_id;	/* id of last marked msg; checked in esb_reply */
#else		/**/
#define	SINFO_XTRA_SIZE	(3*sizeof(void *) + 2*sizeof(long) )
	char si_userspace_opaque[SINFO_XTRA_SIZE];
#endif		/**/

	struct {
		unsigned int	oobinline  : 1;	/* == 1 OOB received inline */
		unsigned int	oobavail   : 1;	/* == 1 OOB data available */
						/* via GETOOB */
		unsigned int	oobpending : 1;	/* == 1 M_PCSIG/SIGURG seen, */
						/* T_EXDATA_IND not yet */
		unsigned int	markwait   : 1;	/* == 1 waiting data to */
						/* clear select() X flag */
		unsigned int	pollset    : 1;	/* == 1 MSGNOGET msg present */
						/* on band OOB_BAND */
		unsigned int	rwnd_closing : 1; /* == 1 while T_optmgmt_req */
						  /* waiting for ack */
		unsigned int	si_flags_pad : 10;
	} si_flags;
	char	si_device_name[NAMELEN];/* Name used in open() for */
					/* socket(domain, type, ...) */
	char	si_oobdata;		/* Current OOB data byte */
					/* (valid only if oobavail != 0). */

} SINFO, * SINFOP;

#if ((CPU_FAMILY==I960) && (defined __GNUC__))
#pragma align 0                 /* turn off alignment requirement */
#endif  /* CPU_FAMILY==I960 */

#ifdef __cplusplus
}
#endif

#endif	/* _SOCKMOD_ */

#endif /* __INCsockmodh */
