/** Copyright (c) 1989-1994  Mentat Inc.
 ** sthmodsw.h 4.5, last change 8/31/94
 **/

#ifndef _STHMODSW_
#define _STHMODSW_

#ifndef WRS
#ifndef lint
static	char	sthmodsw_h_sccsid[] = "@(#)sthmodsw.h 4.5";
#endif
#endif /* WRS */

#ifndef _STROPTS_
#include <stropts.h>
#endif

#ifndef _SQLVL_
#include <sqlvl.h>
#endif

/*
 * Flags for m_flags field.  Only F_MODSW_OLD_OPEN, F_MODSW_IS_DEVICE,
 * and F_MODSW_QPROTECTED are exported for use by outsiders in install
 * OSRs; they are defined in sthmodsw.h.  F_MODSW_TO_BE_FREED is used
 * internally.
 */
#define	F_MODSW_OLD_OPEN	0x01	/* Module supports old-style (V.3) */
					/* open/close parameters */
#define	F_MODSW_IS_DEVICE	0x02	/* Entry is a device. */
#define	F_MODSW_QPROTECTED	0x08	/* Wants QPROTECTED bit. */

#ifdef __cplusplus
extern "C" {
#endif

extern	int	dcookie_to_dindex(   int cookie   );

extern	char *	dcookie_to_name(   int cookie   );

extern	int	dindex_to_cookie(   int index   );

extern	char *	dindex_to_name(   int index   );

extern	struct streamtab *	dindex_to_str(   int index   );

extern	int	dname_to_dcookie(   char * name   );

extern	int	dname_to_dindex(   char * name   );

extern	int	dname_to_sqlvl(   char * name   );

extern	struct streamtab *	dname_to_str(   char * name   );

extern	struct streamtab *	dqinfo_to_str(   struct qinit * qi   );

extern	int	fname_to_sqlvl(   char * name   );

extern	struct streamtab *	fname_to_str(   char * name   );

extern	void	get_device_names(   struct msgb * mp   );

extern	void	get_module_names(   struct msgb * mp   );

extern	void	get_mod_and_dev_names(   struct msgb * mp   );

extern	struct streamtab *	mid_to_str(   unsigned short mid   );

extern	SQHP	modsw_alloc_dev_sqh(   void   );

extern	void	modsw_dev_deref(   dev_t dev   );

extern	void	modsw_dev_last_ref(   dev_t dev   );

extern	void	modsw_dev_save_pmux_top(   struct sth_s * sth   );

extern	boolean	modsw_dev_sqh_insert(   SQHP sqh, dev_t dev, boolean locked   );

extern	struct sth_s *	modsw_dev_to_pmux_top(   dev_t dev   );

extern	SQHP	modsw_dev_to_sqh(   dev_t dev, boolean create   );

extern	OSR_STATUS	modsw_install(   OSRP osr   );

extern	int	modsw_mark_for_removal(   char * name, boolean is_device   );

extern	OSR_STATUS	modsw_remove(   OSRP osr   );

#ifndef MPS_NO_UNLOAD
extern	void	modsw_unload(   void   );
#endif

extern	boolean	module_uses_old_style_open(   struct streamtab * str   );

extern	char *	qinfo_to_name(   struct qinit * qi   );

extern	SQHP	sqh_set_parent(   queue_t * q, struct streamtab * str   );

extern	SQHP	sqh_unlink_writer(   queue_t * q   );

#ifdef MPS_DEBUG
extern	void	dump_module_names(   void   );
#endif

#ifdef __cplusplus
};
#endif

#endif	/* _STHMODSW_ */
