/* Copyright 1995-1997 Wind River Systems, Inc. */

/*
modification history
--------------------
01c,27feb97,bjl  removed extra #ifdef __cplusplus {
01b,20aug95,jag  modify header inclusion paths.
01a,02aug95,dzb  changed header inclusion to be absolute path.
*/

#ifndef __INCstrlogh
#define __INCstrlogh

/** Copyright (c) 1993  Mentat Inc.
 ** strlog.h 4.3, last change 4/15/94
 **/

#ifndef _STRLOG_
#define	_STRLOG_

#ifndef WRS
static char	strlog_h_sccsid[] = "@(#)strlog.h	4.3";
#endif

#if ((CPU_FAMILY==I960) && (defined __GNUC__))
#pragma align 1                 /* tell gcc960 not to optimize alignments */
#endif  /* CPU_FAMILY==I960 */

struct log_ctl {
	short	mid;
	short	sid;
	char	level;
	short	flags;
	long	ltime;
	long	ttime;
	int	seq_no;
};

#define	SL_FATAL	0x1	/* Fatal error */
#define	SL_NOTIFY	0x2	/* Notify the system administrator */
#define	SL_ERROR	0x4	/* Pass message to error logger */
#define	SL_TRACE	0x8	/* Pass message to tracer */
#define	SL_CONSOLE	0x10	/* Print the message on the console */
#define	SL_WARN		0x20	/* Warning */
#define	SL_NOTE		0x40	/* Notice this message */

struct trace_ids {
	short	ti_mid;
	short	ti_sid;
	char	ti_level;
};

#if ((CPU_FAMILY==I960) && (defined __GNUC__))
#pragma align 0                 /* turn off alignment requirement */
#endif  /* CPU_FAMILY==I960 */

#ifndef MIOC_CMD
#include "miioccom.h"
#endif	/* MIOC_CMD */

#define	I_TRCLOG	MIOC_CMD(MIOC_STRLOG, 1)
#define	I_ERRLOG	MIOC_CMD(MIOC_STRLOG, 2)

#define	LOGMSGSZ	128

#ifdef __cplusplus
extern "C" {
#endif

extern	int	strlog(   short mid, short sid, char level, unsigned short flags, char * fmt, ...   );

#ifdef __cplusplus
};
#endif

#endif	/* _STRLOG_ */

#endif /* __INCstrlogh */
