/* strmSockLib.h - streams socket header */

/* Copyright 1984-1995 Wind River Systems, Inc. */

/*
modification history
--------------------
01a,01aug95,dzb  written.
*/

#ifndef __INCstrmSockLibh
#define __INCstrmSockLibh

#ifdef __cplusplus
extern "C" {
#endif

/* includes */

#include "sockFunc.h"

/* function declarations */

#if defined(__STDC__) || defined(__cplusplus)

extern	SOCK_FUNC *strmSockLibInit (void);
extern 	int strmBind (int sd, const struct sockaddr *name, int namelen);
extern	int strmConnect (int sd, const struct sockaddr *name, int namelen);
extern	int strmGetpeername (int sd, struct sockaddr *name, int *namelen);
extern	int strmGetsockname (int sd, struct sockaddr *name, int *namelen);
extern	int strmGetsockopt (int sd, int level, int optname, char *optval,
                int *optlen);
extern	int strmListen (int sd, int backlog);
extern	int strmSetsockopt (int sd, int level, int optname,
                const char *optval, int optlen);
extern	int strmShutdown (int sd, int how);
extern	int strmAccept (int sd, struct sockaddr *addr, int *addrlen);
extern	int strmRecv (int sd, char *buf, int len, int flags);
extern	int strmRecvfrom (int sd, char *buf, int len, int flags,
                struct sockaddr *from, int *fromlen);
extern	int strmRecvmsg (int sd, struct msghdr *msg, int flags);
extern	int strmSend (int sd, const char *buf, int len, int flags);
extern	int strmSendto (int sd, const char *buf, int len, int flags,
                const struct sockaddr *to, int tolen);
extern	int strmSendmsg (int sd, struct msghdr *msg, int flags);
extern	int strmSocket (int domain, int type, int protocol);

extern	STATUS strmSockProtoAdd (int family, int type, char *devName);
extern	STATUS strmSockProtoDelete (int family, int type);
extern	char * strmSockDevNameGet (int family, int type);

#else   /* __STDC__ */

extern	SOCK_FUNC *strmSockLibInit ();
extern 	int strmBind ();
extern	int strmConnect ();
extern	int strmGetpeername ();
extern	int strmGetsockname ();
extern	int strmGetsockopt ();
extern	int strmListen ();
extern	int strmSetsockopt ();
extern	int strmShutdown ();
extern	int strmAccept ();
extern	int strmRecv ();
extern	int strmRecvfrom ();
extern	int strmRecvmsg ();
extern	int strmSend ();
extern	int strmSendto ();
extern	int strmSendmsg ();
extern	int strmSocket ();

extern	STATUS strmSockProtoAdd ();
extern	STATUS strmSockProtoDelete ();
extern	char * strmSockDevNameGet ();

#endif  /* __STDC__ */

#ifdef __cplusplus
}
#endif

#endif	/* __INCstrmSockLibh */
