/* wdbRegs.h - header file for register layout as view by the WDB agent */

/* Copyright 1984-1994 Wind River Systems, Inc. */

/*
modification history
--------------------
01d,12feb99,dbt  fixed __STDC__ use.
01c,17dec96,ms	 WDB now uses FP_CONTEXT instead of FPREG_SET (SPR 7654).
01b,25may95,ms	 defined register objects.
01a,03may95,ms   written.
*/

#ifndef __INCwdbRegsh
#define __INCwdbRegsh

/* includes */

#include "wdb/dll.h"
#include "wdb/wdb.h"
#include "regs.h"		/* WDB_IU_REGS = VxWorks REG_SET */
#include "fppLib.h"		/* WDB_FPU_REGS = VxWorks FP_CONTEXT */

/* data types */

#if     CPU_FAMILY==MC680X0
typedef struct WDB_IU_REGS
    {
    REG_SET     regSet;
    int         padding;
    } WDB_IU_REGS;
#else
typedef REG_SET WDB_IU_REGS;
#endif

typedef FP_CONTEXT WDB_FPU_REGS;

typedef struct
    {
    dll_t		node;
    WDB_REG_SET_TYPE	regSetType;		/* type of register set */
    void		(*save) (void);		/* save current regs */
    void		(*load) (void);		/* load saved regs */
    void		(*get)  (char ** ppRegs); /* get saved regs */
    void		(*set)  (char *pRegs);	/* change saved regs */
    } WDB_REG_SET_OBJ;

/* function prototypes */

#ifdef  __STDC__

extern	WDB_REG_SET_OBJ * wdbFpLibInit		(void);
extern	void              wdbExternRegSetObjAdd (WDB_REG_SET_OBJ *pRegSet);

#else	/* ! __STDC__ */

extern	WDB_REG_SET_OBJ * wdbFpLibInit		();
extern	void              wdbExternRegSetObjAdd ();

#endif	/* __STDC__ */

#endif  /* __INCwdbRegsh */

