/* Copyright 1990-1992 Wind River Systems, Inc. */
/*
modification history
-------------------------
01a,30jun97,rjc added pragma align stuff
*/

#ifndef __INCos_lsrh 
#define __INCos_lsrh

/**********************************************
os_lsr.h

OSPF link state request and update definitions

copyright phase2 networks inc, 1994
all rights reserved

SID: 1.1
Revision History:


    1.1	94/12/04 09:38:25 root
	date and time created 94/12/04 09:38:25 by root

**********************************************/

#if ((CPU_FAMILY==I960) && (defined __GNUC__))
#pragma align 1                 /* tell gcc960 not to optimize alignments */
#endif  /* CPU_FAMILY==I960 */

/***********************************************
 * definitions for link-state requests and link-state updates 
 ***********************************************/

#define LSR_SIZE 12  /* Size of an element of an LS Request packet */
                     /* Not the size of struct lsr */

typedef struct lsr {
    byte 		lsr_lstype[4];
    byte 		lsr_lsid[4];
    byte 		lsr_adv_rtid[4];
    word 		ls_age;
    word 		ls_csum;
    sdword 	ls_seq;
} LSR, *lsr_pt;

#define LSR_PACKET_FIRST_REQ(packet) ( \
    OSPF_PACKET_LENGTH(packet) > OSPF_HEADER_SIZE ? \
    ((LSR*) ((byte*)packet+OSPF_HEADER_SIZE)) : \
    NULL \
)

#define LSR_PACKET_NEXT_REQ(packet,lsr) ( \
    OSPF_PAST_END(packet,lsr,LSR_SIZE) ? \
    NULL:\
    ((LSR*) ((byte*)lsr+LSR_SIZE))\
)

#define LSR_LSTYPE(lsr) (n2u32((lsr)->lsr_lstype))

#define LSR_LSID(lsr) (n2ipa((lsr)->lsr_lsid))

#define LSR_ADV_RTR(lsr) (n2ipa((lsr)->lsr_adv_rtid))

#define LSU_HEADER_SIZE 4
typedef struct {
  byte filler[OSPF_HEADER_SIZE];
  byte lsu_num_lsa[4];
} LSU, *lsu_ptr;

#define LSU_FIRST_LSA(pack) ((LSA*)((byte*)(pack)+OSPF_HEADER_SIZE+LSU_HEADER_SIZE))
#define LSU_NEXT_LSA(lsa) ((LSA*)(((byte*)lsa)+n2u16(lsa->ls_len)))
#define LSU_NUM_ENTRIES(pack) (n2u32(((LSU*)pack)->lsu_num_lsa))
#define LSA_SIZE(lsai) (n2u16((lsai)->i_lsa->ls_len))

typedef struct lsa_ack {
  struct lsa_ack *ack_fwd;
  struct lsa_ack *ack_bwd;
  struct lsa_hdr lsa_header;
} lsa_ack, *lsa_ack_pt;

#if ((CPU_FAMILY==I960) && (defined __GNUC__))
#pragma align 0                 /* turn off alignment requirement */
#endif  /* CPU_FAMILY==I960 */

#define LSACK_FIRST_LSA(pack) ((LSA*)((byte*)(pack)+OSPF_HEADER_SIZE))

#define ACK_TYPE 5

#endif /* __INCos_lsrh */
