/* Copyright 1990-1992 Wind River Systems, Inc. */
/*
modification history
-------------------------
01a,30jun97,rjc added pragma align stuff
*/

#ifndef __INCos_pkth
#define __INCos_pkth

/*******************************************
os_pkt.h

OSPF header definitions


copyright phase2 networks inc, 1994
all rights reserved

SID: 1.2
Revision History:


    1.2	95/11/27 13:37:14 root
	multiple incarnation support

    1.1	94/12/04 09:38:30 root
	date and time created 94/12/04 09:38:30 by root

*******************************************/
#ifndef OSPF_PACKET_H
#define OSPF_PACKET_H 1

#define AUTH_KEY_SIZE 8
#define OSPF_HEADER_SIZE 24

#if ((CPU_FAMILY==I960) && (defined __GNUC__))
#pragma align 1                 /* tell gcc960 not to optimize alignments */
#endif  /* CPU_FAMILY==I960 */

typedef struct ospf_packet {
  byte ospf_version;
  byte ospf_type;
  byte ospf_length[2];
  byte ospf_rtid[4];
  byte ospf_area_id[4];
  byte ospf_cksum[2];
  byte ospf_au_type[2];
  byte ospf_auth_key[8];
} ospf_packet, *ospf_packet_pt;

#if ((CPU_FAMILY==I960) && (defined __GNUC__))
#pragma align 0                 /* turn off alignment requirement */
#endif  /* CPU_FAMILY==I960 */

/* write some macros to go here */
#define OSPF_PACKET_VERSION(packet) ((packet)->ospf_version)

#define OSPF_PACKET_TYPE(packet) ((packet)->ospf_type)

#define OSPF_PACKET_LENGTH(packet) (n2u16((packet)->ospf_length))

#define OSPF_PACKET_RTID(packet) n2ipa(((packet)->ospf_rtid))

#define OSPF_PACKET_AREA_ID(packet) n2ipa((packet)->ospf_area_id)

#define OSPF_PACKET_CKSUM(packet) (n2u16((packet)->ospf_cksum))

#define OSPF_PACKET_AU_TYPE(packet) (n2u16((packet)->ospf_au_type))

#define OSPF_PACKET_AUTH_KEY(packet) ((packet)->ospf_auth_key)

#define OSPF_PAST_END(pkt,ptr,incr) ( ((byte*)pkt+OSPF_PACKET_LENGTH(pkt)) <= ((byte*)ptr+incr))


#if defined(GEN_TRACE) || defined(SEND_DEBUG)
fnc_prot(char*,ipa2string,(ipa))
#define SEND_TRACE(p,dst) printf("(%3d)Sending %s packet, length %d, to %s\n",\
	(int)ospfNode->n_tics,ospf_packet_type(p),OSPF_PACKET_LENGTH(p),ipa2string(dst))
#else
#define SEND_TRACE(p,dst) /* nothing */
#endif

#endif /* OSPF_PACKET_H */

#endif /* __INCos_pkth */
