/* Copyright 1990-1992 Wind River Systems, Inc. */
/*
modification history
-------------------------
01a,30jun97,rjc added pragma align stuff
*/

#ifndef __INCos_porth
#define __INCos_porth

/* os_port.h */

/*
modification history
-------------------------
01c,03jun97,rjc auto vlink config removed .
01b,14apr97,rjc changes to trace macros.
01a,05dec96,rjc generated from p-2 source
*/

/*

os_port.h

OSPF target platform specific definitions

copyright phase2 networks 1994
all rights reserved


SID: 1.10
Revision History:


    1.10	96/02/08 11:19:44 root
	mod SUSPEND #def

    1.9	96/02/06 22:30:13 root
	extern api mods

    1.8	96/01/30 15:28:20 jpp
	add spf hold, check spf suspend

    1.7	95/11/27 13:37:15 root
	multiple incarnation support

    1.6	95/11/09 09:45:20 root
	add mospf

    1.5	95/10/23 23:12:10 root
	use cmn link fcns

    1.4	95/10/05 18:00:09 root
	move ASSERT

    1.3	95/10/03 14:30:29 root
	move common defs to p2port.h

    1.2	95/01/02 17:42:45 root
	final test

    1.1	94/12/04 09:38:31 root
	date and time created 94/12/04 09:38:31 by root

******************************************/


#define PENT_BSIZE		   64
#define PENT_MAXBLK         10

/* used for allocations, value used in pdus is settable */

/* size of hashing tables */
/* we avoid division, so table size is binary number */
#define NBR_HASH_BITS       4
#define NBR_HASHES          (1 << NBR_HASH_BITS)
#define LSD_HASH_BITS       4
#define LSD_HASHES          (1 << LSD_HASH_BITS)
#define CIRC_HASH_BITS      1
#define CIRC_HASHES         (1 << CIRC_HASH_BITS)

/* true if virtual links to all area borders should
be automatically created when an area border router
is found.
*/ 
#define DEF_AUTO_VLINK	   0

#define ALL_METRICS         1       /* support all routing metrics */


/* Not being supported by wrs for the time being hence LOAD_SHARE is set 
   to 0 */

/* true if multiple paths are supported */

/* xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx */

#define LOAD_SHARE          1
#if LOAD_SHARE
#define MAX_MSPLIT          3
#else
#define MAX_MSPLIT          1
#endif /* LOAD_SHARE */

/* xxxxxxxxxxxxxxxxxxxxxxxxxxx what the heck is this */

#define P2_MOSPF		   0

/* MEMORY ALLOCATION MACROS */

/*
void ospfFree (void *);
void * ospfMalloc (int);
*/


/* alloc output frame */
#define ospfOfAlloc(len)        ospf_oframe_alloc(len)  /* returns ibd_pt*/
#define ospfOfFree(ptr)         ospf_oframe_free(ptr)

/* free an input packet xxxxxxxxxxxxxxx */
#define ospfIfFree(ptr)        

#define ospfNbrAlloc(len)       (Neighbor *)ospfMalloc(len) /* adj structure */
#define ospfNbrFree             ospfFree

#define ospfNodeAlloc()           ospfMalloc(sizeof(OSPF_NODE))

#define ospfCircAlloc()   	  ospfMalloc(sizeof(OS_CIRC))
#define ospfCircFree(ptr)    	  ospfFree(ptr)


/* link state pdus */
#define ospfLsaAlloc(len)       ospfMalloc(len)
#define ospfLsaFree(ptr)        ospfFree(ptr)

#define ospfRouteAlloc(len)     ospfMalloc(len) /* route hash*/
#define ospfRouteFree(ptr)      ospfFree(ptr)


/* various lsp structures */
#define ospfLsdAlloc(len)       ospfMalloc(len)
#define ospfLsdFree(ptr)   	  ospfFree(ptr)

#define ospfTimerAlloc()		  ospfMalloc(sizeof(OTIMER))
#define ospfTimerFree(ptr)	  ospfFree(ptr)

#define ospfCRAlloc()		  ospfMalloc(sizeof(CFG_RANGE))
#define ospfCRFree(ptr)		  ospfFree(ptr)

#define ospfAreaAlloc()		  ospfMalloc(sizeof(AREA))
#define ospfAreaFree(ptr)	  ospfFree(ptr)

#define ospfNbmaAlloc()		  ospfMalloc(sizeof(NBMA_DST))
#define ospfNbmaFree(ptr)	  ospfFree(ptr)

#define ospfHostRtAlloc()	  ospfMalloc(sizeof(HOST_RT))
#define ospfHostRtFree(ptr)	  ospfFree(ptr)

#define ospfDBReqNodeAlloc(s) (db_req_pt)ospfMalloc(s)
#define ospfDBReqNodeFree(ptr)  ospfFree(ptr)

#define ospfRetransAlloc(s) ((retrans_pt)ospfMalloc(s))
#define ospfRetransFree(ptr) ospfFree(ptr)

#define ospfAcknodeAlloc(s) (lsa_ack*)ospfMalloc(s);
#define ospfAcknodeFree(ptr) ospfFree(ptr)

#define ospf_db_packet_alloc(s) ospfMalloc(s)
#define ospf_db_packet_free(p)  ospfFree(p)


/* NOTE: this mem copy assumes a 0 len copy is valid !!! */
#define ospfCopyMem(xdst,xsrc,xlen)  p2CopyMem((byte *)(xdst),(byte *)(xsrc),xlen)

#define ospfFillMem(xdst,xdata,xlen)   p2FillMem((byte *)xdst,xdata,xlen) /*fill */

#define ospfCmpMem(xdst,xsrc,xlen)  p2CmpMem((byte *)(xdst),(byte *)(xsrc),xlen)

/* proto defs moved to p2port.h */
#define ospfLink p2Link
#define ospfGenLink p2GenLink
#define ospfULink p2ULink


/* byte access macros moved to p2port.h */
#define n2ipa(xpdua) (ipa)uns_p2l(xpdua)
#define ipa2n(xpdua,xval)  uns_l2p(xpdua,xval)

extern int ospfTrace ;

#define TRACE_NBR(x)	if(ospfTrace && ospfNode->n_trnbr) printf x
#define TRACE_LSA(x)	if(ospfTrace && ospfNode->n_trlsa) printf x
#define TRACE_DR(x)		if(ospfTrace && ospfNode->n_trdr) printf x
#define TRACE_DEF_NBR	1
#define TRACE_DEF_DR	1
#define TRACE_DEF_LSA	1

/* xxxxxxxxxxxxxxxxxxxxxxxxxx */
/* min time between spf runs */
#define OSPF_SPF_HOLD	3

/* xxxxxxxxxxxxxxxxxxxxxxxxxxx */
/* set to true if want to allow suspend in middle of spf
   run. IF SUSPENDED, ENGINE MAY NOT BE RE-ENTERED.
*/
#define OSPF_SUSPEND	0
#define OSPF_SUSPEND_CNT 2000

#endif /* __INCos_porth */
