/* Copyright 1990-1992 Wind River Systems, Inc. */
/*
modification history
-------------------------
01a,30jun97,rjc added pragma align stuff
*/

#ifndef __INCos_prexth
#define __INCos_prexth

/**************************************************
os_prext.h

OSPF function prototypes for externally available
functions.


copyright phase2 networks inc, 1994
all rights reserved

SID: 1.5
Revision History:


    1.5	96/04/17 11:21:22 root
	mod vcirccreate for snmp test

    1.4	96/03/29 09:56:58 root
	misc warnings

    1.3	96/03/06 07:59:08 root
	add protos

    1.2	96/02/08 11:20:06 root
	add snmp protos

    1.1	96/02/06 22:28:29 root
	date and time created 96/02/06 22:28:29 by root

**************************************************/

/* inbound calls */
fnc_prot(int,  ospfAddArea, (ipa,int,int))
fnc_prot(int,  ospfDelArea, (ipa))
fnc_prot(int,  ospfDelVlinks, (ipa))
fnc_prot(int,  ospfAddRange, (ipa, ipna_pt,int))
fnc_prot(int,  ospfDelRange, (ipa, ipna_pt))
fnc_prot(int,  ospfAddExtRt,(ipna_pt,ipa,int,int,int,int,ipa))
fnc_prot(int,  ospfDelExtRt,(ipna_pt,int,int,int))
fnc_prot(void, ospfPurgeExtRt,(void))

fnc_prot(void *, ospfCircCreateExt,(int,void *,ipna_pt,unsigned long))
fnc_prot(void *, ospfVCircCreateExt,(ipa,ipa,int))
fnc_prot(int, ospfCircDeleteExt,(void *))
fnc_prot(int, ospfVCircDeleteExt,(ipa,ipa))

fnc_prot(int, ospfAddHostRt,(ipa,int,ipa))
fnc_prot(int, ospfDelHostRt,(ipa))
fnc_prot(void, ospfTic,(void))
fnc_prot(void *, ospfAddNbmaDstExt,(ipa,void *,int))
fnc_prot(int, ospfDelNbmaDst,(ipa ,void *))
fnc_prot(int, ospfCircEnable,(void *))
fnc_prot(int, ospfCircDisable,(void *))
fnc_prot(void, ospfCircEvent,(void *,int,void *,void *))
fnc_prot(int, p2OspfInit,(void))
fnc_prot(int,  ospfEnable,(void))
fnc_prot(int,  ospfDisable,(void))
fnc_prot(void ,ospfReceiveExt,(char *, int, void *, ipa, ipa))
fnc_prot(int, ospfSetCircArea,(void *,ipa,int))
fnc_prot(int, ospfNodeModify,(int, void *))
fnc_prot(int, ospfCircModify,(void *,int, void *,int))
fnc_prot(int, ospfVCircModify,(ipa,ipa,int, void *,int))
fnc_prot(int, ospfAreaModify,(ipa ,int , void *))
fnc_prot(void, ospfCmdDisp,(int ,SNMP_CB *))
fnc_prot(void, ospfDoSnmp,(SNMP_CB *))

/* outbound calls */
fnc_prot(void, osDLStart,(void *))
fnc_prot(void, ospfAddMcast,(ipa))
fnc_prot(int , ospfAddRoute,(pathent_pt,int,ipa))
fnc_prot(void, ospfEndRtUpdate,(int,ipa))
fnc_prot(int,   ospfGetIfIndex,(void *))
fnc_prot(int , ospfModRoute,(pathent_pt))
fnc_prot(int, ospfDupRtFilter,(pathent_pt))
#if P2_MOSPF
fnc_prot(int, ospfRtLookup,(ipa,unsigned long *,ipa *,ipa *,void *,ipna_pt))
#else
fnc_prot(int, ospfRtLookup,(ipa,unsigned long *,ipa *))
#endif
fnc_prot(void, ospfStartRtUpdate,(int,ipa))
fnc_prot(int, ospf_transmit,(ipa,void *,ibd_pt,int,int))

#endif /* __INCos_prexth */
