/* Copyright 1990-1992 Wind River Systems, Inc. */
/*
modification history
-------------------------
01a,30jun97,rjc added pragma align stuff
*/

#ifndef __INCos_spfh
#define __INCos_spfh

/***********************************************
os_spf.h:

spf decision process definitions
copyright phase2 networks 1994
all rights reserved

SID: 1.5
Revision History:


    1.5	96/02/06 22:30:33 root
	extern api mods

    1.4	95/11/09 09:45:33 root
	add mospf

    1.3	95/05/02 14:19:44 root
	add tos

    1.2	95/03/13 09:23:24 root
	optimizations

    1.1	94/12/04 09:38:39 root
	date and time created 94/12/04 09:38:39 by root

************************************************/

#if ((CPU_FAMILY==I960) && (defined __GNUC__))
#pragma align 1                 /* tell gcc960 not to optimize alignments */
#endif  /* CPU_FAMILY==I960 */

/* a block of pathent entries */
typedef struct pathent_blk {
	struct pathent_blk		*peb_link;
	struct path_entry		 peb_pent;
}PE_BLK, *peblk_pt;


/* SPF run types */
#define SPF_RUNALL		1		/* intra, inter area */
#define SPF_RUNINTER	2		/* inter area */
#define SPF_RUNTRANSIT	8		/* transit adj */
#define SPF_RUNEXTERN	0x10		/* AS external */


/* an external gateway dest struct, see spec sec 12.4.5 */
typedef struct egp_dest{

	struct egp_dest	*e_fwd;
	struct egp_dest	*e_bwd;
	int				e_state;
	ipa				e_dest;
	dword			e_cost;
						/* possbile nexthops */
	ipa				e_nh;
	struct circuit		*e_nc;
}EGP_DEST, *egpd_pt;

#define EGPD_VALID		1
#define EGPD_INVALID	2


struct ospf_spf_context{
	struct area 	*c_area;
	int 			is_spf_intra;
	int			spf_tos;
	int			is_mospf;
#if P2_MOSPF
	ipa			mospf_grp;
	pathent_pt	mospf_my_vertex;
	int			mospf_init_type;
	struct rtr_link		*mospf_rle;
#endif
};

#if ((CPU_FAMILY==I960) && (defined __GNUC__))
#pragma align 0                 /* turn off alignment requirement */
#endif  /* CPU_FAMILY==I960 */

#endif /* __INCos_spfh */
