/* Copyright 1990-1992 Wind River Systems, Inc. */
/*
modification history
-------------------------
01a,30jun97,rjc added pragma align stuff
*/

#ifndef __INCos_typesh
#define __INCos_typesh

/********************************************
os_types.h

copyright phase2 networks 1992
all rights reseved

OSPF data types


SID: 1.7
Revision History:


    1.7	96/03/29 09:56:45 root
	compiler complaint abourt (-ipadd)

    1.6	96/02/06 22:30:41 root
	extern api mods

    1.5	95/10/23 23:04:42 root
	check for mask holes in addrange

    1.4	95/07/10 10:32:11 root
	common types

    1.3	95/06/22 08:57:53 root
	make cmn

    1.2	95/05/11 10:59:01 root
	comments

    1.1	94/12/04 09:38:42 root
	date and time created 94/12/04 09:38:42 by root

***********************************************/
#ifndef _ospf_types_h
#define _ospf_types_h

/***********************************

NOTE: all following are also defined
in IP engine. DO NOT CHANGE WITHOUT
CHANGING IP!!!!
**********************************/

/* ip network address and mask */
/* NOTE: data is stored in these structs in net
   native order, ie MSB first, which may not
   correspond to machine order. A magnitude 
   comparison of ipaddresses is therefore not
   possible. However, masks can be compared
   because we require no "holes" in subnet masks.
*/

typedef unsigned long ipa;

#if ((CPU_FAMILY==I960) && (defined __GNUC__))
#pragma align 1                 /* tell gcc960 not to optimize alignments */
#endif  /* CPU_FAMILY==I960 */

typedef struct ipnetaddr{
	ipa	 	ip_add;		/* 32 bit address */
	ipa		ip_mask;		/* subnet mask */
} IPNA, *ipna_pt;

typedef struct{
	unsigned char	k[8];
}authkey_t;

#if ((CPU_FAMILY==I960) && (defined __GNUC__))
#pragma align 0                 /* turn off alignment requirement */
#endif  /* CPU_FAMILY==I960 */

/* NLPID for IP */
#define IP_NPID		0xcc

/* class related */
/* we always store in net order (MSB first) */
#define IP_CLASS_A_MAX	127
#define IP_CLASS_B_MAX	191
#define IP_EXT_ADD		224
#define IP_LOOP		SWAP32(0x7f000000)
#define IP_CLASS_A_MSK	SWAP32(0xff000000)
#define IP_CLASS_B_MSK	SWAP32(0xffff0000)
#define IP_CLASS_C_MSK	SWAP32(0xffffff00)

#define IP_CLASS_MASK(ipadd,res)	{ \
  if( *(byte *)(ipadd) <= IP_CLASS_A_MAX ) *(ipa *)(res) = IP_CLASS_A_MSK; \
  else if( *(byte *)(ipadd) <= IP_CLASS_B_MAX ) *(ipa *)(res) = IP_CLASS_B_MSK; \
  else *(ipa *)(res) = IP_CLASS_C_MSK;  }

/* true if "hole" in mask; true because x&-x always has 
   exactly one bit set, which should be equal -x */
#define IP_MASK_HOLE(ipadd) ((ipadd&(~ipadd+1)) != (~ipadd+1))

/* macro to set router ID */
#define SET_RTID(x)		SWAP32( (dword)(x) )		

#endif /* _ospf_types_h */

#endif /* __INCos_typesh */
