/* led.h - Mentat Portable STREAMS O.S dependent file */

/* Copyright 1994-1995 Wind River Systems, Inc. */
#include "copyright_wrs.h"

/*   
modification history
--------------------
01a,06sep95,jag  added history and defines for OTHER_MI_STRTOL, OTHER_MI_BZERO
*/

#ifndef __INCmiutilh
#define __INCmiutilh

/** Copyright (c) 1988-1994  Mentat Inc.
 ** miutil.h 4.2, last change 6/15/94
 **/

#ifndef _MIUTIL_
#define _MIUTIL_

#ifndef WRS
#ifndef lint
static	char	miutil_h_sccsid[] = "@(#)miutil.h 4.2";
#endif
#endif /* WRS */

#ifndef _MISTDARG_
#include <mistdarg.h>
#endif

#define	MI_COPY_IN		1
#define	MI_COPY_OUT		2
#define	MI_COPY_DIRECTION(mp)				     \
	(((unsigned char *)&(mp)->b_cont->b_prev)[0])
#define	MI_COPY_COUNT(mp)				     \
	(((unsigned char *)&(mp)->b_cont->b_prev)[1])
#define	MI_COPY_RVAL(mp)	(*(int *)&(mp)->b_cont->b_next)
#define	MI_COPY_CASE(dir,cnt)	((int)(((cnt)<<2)|dir))
#define	MI_COPY_STATE(mp)				     \
	((int)MI_COPY_CASE(MI_COPY_DIRECTION(mp),MI_COPY_COUNT(mp)))

#if ((CPU_FAMILY==I960) && (defined __GNUC__))
#pragma align 1                 /* tell gcc960 not to optimize alignments */
#endif  /* CPU_FAMILY==I960 */

/* mblk encapsulation */
typedef struct mbe_s {
	u32	mbe_len;
	u32	mbe_type;
	u32	mbe_hlen;
	u32	mbe_tlen;
} mbe_t;

typedef struct gq_s {
	struct	gq_s	* gq_next;
	struct	gq_s	* gq_prev;
	char		* gq_data;
} GQ, * GQP;

#if ((CPU_FAMILY==I960) && (defined __GNUC__))
#pragma align 0                 /* turn off alignment requirement */
#endif  /* CPU_FAMILY==I960 */

#ifdef __cplusplus
extern "C" {
#endif

#ifdef USE_MI_BCOPY
extern	void	bcopy(   char * src, char * dst, int len   );

extern	void	bzero(   char * buffer, int nbytes   );

#endif	/* USE_MI_BCOPY */

extern	int	mi_addr_scanf(   char * str, char ** ptr, int base, char * dest, int len, char * to_skip   );

extern	queue_t *	mi_allocq(   struct streamtab * st   );

extern	void	mi_bufcall(   queue_t * q, int size, int pri   );

extern	int	mi_close_comm(   char ** mi_opp_orig, queue_t * q   );

extern	void	mi_close_detached(   char ** mi_opp_orig, char * ptr   );

extern	mblk_t	* mi_copyb(   mblk_t *  bp   );

extern	void	mi_copyin(   queue_t * q, mblk_t * mp, char * uaddr, int len   );

extern	void	mi_copyout(   queue_t * q, mblk_t * mp   );

extern	mblk_t	* mi_copyout_alloc(   queue_t * q, mblk_t * mp, char * uaddr, int len   );

extern	void	mi_copy_set_rval(   mblk_t * mp, int rval   );

extern	void	mi_copy_done(   queue_t * q, mblk_t * mp, int err   );

extern	int	mi_copy_state(   queue_t * q, mblk_t * mp, mblk_t * * mpp   );

extern	void	mi_detach(   queue_t * q, char * ptr   );

extern	char *	mi_gq_head(   GQP h   );

extern	void	mi_gq_in(   GQP h, GQP t   );

extern	void	mi_gq_init(   GQP a, char * d   );

extern	void	mi_gq_out(   GQP a   );
extern	int	mi_iprintf(   const char * fmt, va_list ap, int (*putc_func)(char *, int), char * cookie   );

#ifdef SVR3_STYLE
extern	boolean_t	mi_link_device(   queue_t * orig_q, char * name   );
#endif /* SVR3_STYLE */

extern	int	mi_mpprintf(   mblk_t * mp, char * fmt, ...   );

extern	int	mi_mpprintf_nr(   mblk_t * mp, char * fmt, ...   );

extern	int	mi_mpprintf_putc(   char * cookie, int ch   );

extern	char *	mi_next_ptr(   char * ptr   );

extern	unsigned char *	mi_offset_param(   mblk_t * mp, long offset, long len   );

extern	unsigned char *	mi_offset_paramc(   mblk_t * mp, long offset, long len   );

extern	mblk_t *	mi_offset_param_mblk(   mblk_t * mp, long offset, long length, int * err   );

#ifdef SVR3_STYLE
extern	int	mi_open_comm(   char ** mi_opp_orig, uint size, queue_t * q, dev_t dev, int flag, int sflag   );
#endif	/* SVR3_STYLE */

#ifdef SVR4_STYLE
extern	int	mi_open_comm(   char ** mi_opp_orig, uint size, queue_t * q, dev_t * devp, int flag, int sflag, cred_t * credp   );
#endif

extern	char *	mi_open_detached(   char ** mi_opp_orig, uint size, dev_t * devp   );

#ifndef OTHER_MI_OVBCOPY
extern	void	mi_ovbcopy(   u8 * from, u8 * to, int len   );
#endif

extern	void	mi_panic(   char * fmt, ...   );

extern	boolean_t	mi_set_sth_hiwat(   queue_t * q, int size   );

extern	boolean_t	mi_set_sth_lowat(   queue_t * q, int size   );

extern	boolean_t	mi_set_sth_maxblk(   queue_t * q, int size   );

extern	boolean_t	mi_set_sth_wroff(   queue_t * q, int size   );

extern	int	mi_sprintf(   char * buf, char * fmt, ...   );

extern	int	mi_sprintf_putc(   char * cookie, int ch   );

#ifndef OTHER_MI_STRCMP
extern	int	mi_strcmp(   char * cp1, char * cp2   );
#endif

#ifndef OTHER_MI_STRLEN
extern	int	mi_strlen(   char * str   );
#endif

extern	int	mi_strlog(   queue_t * q, ...   );

#ifndef OTHER_MI_STRTOL
extern	long	mi_strtol(   char * str, char ** ptr, int base   );
#endif

extern	mblk_t	* mi_reallocb(   mblk_t * mp, int new_size   );

extern	mblk_t	* mi_tpi_ack_alloc(   mblk_t * mp, uint size, uint type   );

extern	mblk_t	* mi_tpi_conn_con(   mblk_t * trailer_mp, char * src, int src_length, char * opt, int opt_length   );

extern	mblk_t	* mi_tpi_conn_ind(   mblk_t * trailer_mp, char * src, int src_length, char * opt, int opt_length, int seqnum   );

extern	mblk_t	* mi_tpi_conn_req(   mblk_t * trailer_mp, char * dest, int dest_length, char * opt, int opt_length   );

extern	mblk_t	* mi_tpi_data_ind(   mblk_t * trailer_mp, int flags, int type   );

extern	mblk_t	* mi_tpi_data_req(   mblk_t * trailer_mp, int flags, int type   );

extern	mblk_t	* mi_tpi_discon_ind(   mblk_t * trailer_mp, int reason, int seqnum   );

extern	mblk_t	* mi_tpi_discon_req(   mblk_t * trailer_mp, int seqnum   );

extern	mblk_t	* mi_tpi_err_ack_alloc(   mblk_t * mp, int tlierr, int unixerr   );

extern	mblk_t	* mi_tpi_exdata_ind(   mblk_t * trailer_mp, int flags, int type   );

extern	mblk_t	* mi_tpi_exdata_req(   mblk_t * trailer_mp, int flags, int type   );

extern	mblk_t	* mi_tpi_info_req(   void   );
extern	mblk_t	* mi_tpi_ioctl_info_req(   uint id   );

extern	mblk_t	* mi_tpi_ok_ack_alloc(   mblk_t * mp   );

extern	mblk_t	* mi_tpi_ordrel_ind(   void   );

extern	mblk_t	* mi_tpi_ordrel_req(   void   );

extern	mblk_t	* mi_tpi_uderror_ind(   char * dest, int dest_length, char * opt, int opt_length, int error   );

extern	mblk_t	* mi_tpi_unitdata_ind(   mblk_t * trailer_mp, char * src, int src_length, char * opt, int opt_length   );

extern	mblk_t	* mi_tpi_unitdata_req(   mblk_t * trailer_mp, char * dst, int dst_length, char * opt, int opt_length   );

#ifndef OTHER_MI_BZERO
extern	void	mi_bzero(   char * buffer, int nbytes   );
#endif

#ifdef __cplusplus
};
#endif

#endif	/* _MIUTIL_ */

#endif /* __INCmiutilh */
