/* miweld.h - MPS WELD header */

/* Copyright 1984-1995 Wind River Systems, Inc. */

/*
modification history
--------------------
01a,24aug95,sgv  Added copyright
*/

#ifndef __INCmiweldh
#define __INCmiweldh

/** Copyright (c) 1990-1994  Mentat Inc.
 ** miweld.h 4.2, last change 6/15/94
 **/

#ifndef _MIWELD_
#define _MIWELD_

#ifndef WRS
static	char	miweld_h_sccsid[] = "@(#)miweld.h 4.2";
#endif /* WRS */

#ifdef MPS
#ifndef _MPSSQ_
#include <mpssq.h>
#endif
#endif

#if ((CPU_FAMILY==I960) && (defined __GNUC__))
#pragma align 1                 /* tell gcc960 not to optimize alignments */
#endif  /* CPU_FAMILY==I960 */

typedef struct weld_s {
	queue_t	* weld_q1;	/* First rear queue */
	queue_t	* weld_q2;	/* First front queue */
	queue_t	* weld_q3;	/* Second rear queue (optional) */
	queue_t	* weld_q4;	/* Second front queue (optional) */
	int	weld_operation;	/* MI_WELD or MI_UNWELD */
	pfi_t	weld_callback;	/* Callback routine (optional) */
	u32	weld_arg0;	/* Callback argument (optional) */
	u32	weld_arg1;	/* Callback argument (optional) */
	int	weld_state;	/* Internal state (not set by caller) */
	queue_t	* weld_next;	/* More internal state (not set by caller) */
	queue_t	** weld_qpp;	/* More internal state (not set by caller) */
} WELD, * WELDP;

#if ((CPU_FAMILY==I960) && (defined __GNUC__))
#pragma align 0                 /* turn off alignment requirement */
#endif  /* CPU_FAMILY==I960 */

#define	MI_WELD		1
#define	MI_UNWELD	2

#ifdef __cplusplus
extern "C" {
#endif

extern	void	mi_weld(   MBLKP mp   );

#ifdef __cplusplus
};
#endif

#endif	/* _MIWELD_ */

#endif /* __INCmiweldh */
