#ifndef __INCmpssqh
#define __INCmpssqh

/** Copyright (c) 1993, 1994  Mentat Inc.
 ** mpssq.h 4.2, last change 6/15/94
 **/

#ifndef _MPSSQ_
#define _MPSSQ_

#ifndef WRS
#ifndef lint
static	char	mpssq_h_sccsid[] = "@(#)mpssq.h 4.2";
#endif
#endif /* WRS */

#if ((CPU_FAMILY==I960) && (defined __GNUC__))
#pragma align 1                 /* tell gcc960 not to optimize alignments */
#endif  /* CPU_FAMILY==I960 */

/* Synch Queue Definitions (Lock definitions are in milocks.h or led.h.) */

#ifndef OTHER_SQH
typedef struct sqh_s {			/* Sync Queue Head */
	struct sqe_s	* sqh_next;
	struct sqe_s	* sqh_prev;
	MPSLF		sqh_lockf;	/* !=0 --> busy (meaningful only if
					   sqh_parent == ourself) */
	struct sqh_s	* sqh_parent;	/* actual SQH containing lock */
	MPSL		sqh_lock;	/* used only when acquiring SQH to
					   fiddle next/prev */
	struct sqe_s	* sqh_owner;	/* owner (SQP), if sqh_lockf != 0 */
	unsigned int	sqh_refcnt;	/* # of times owner has acquired
					   sqh_lockf */
	struct sqh_s	* sqh_writer_head; /* Head of writer chain. */
	struct sqh_s	* sqh_writer_next; /* Next on writer chain. */
	struct sqh_s	* sqh_writer_head_next; /* Next on writer head list. */
} SQH, * SQHP, ** SQHPP;
#endif

typedef void	(*sqecb_t)(PCELL, mblk_t *);

#ifndef OTHER_SQE
typedef struct sqe_s {			/* Sync Queue Element */
	struct sqe_s	* sqe_next;
	struct sqe_s	* sqe_prev;
	MPSLF		sqe_lockf;
	queue_t		* sqe_target;	/* original target queue */
	u32		sqe_flags;
	sqecb_t		sqe_callback;	/* callback function when this SQE
					   removed from SQH */
	PCELL		sqe_arg0;
	struct msgb	* sqe_arg1_mp;
} SQE, * SQEP;
#endif

struct	q_xtra {			/* Added to queue_t -- see stream.h */
	SQH	qx_sqh;
	SQE	qx_runq_sqe;
	int	qx_sq_cnt;		/* SQ'd count for canput. */
	MPSL	qx_sq_cnt_lock;		/* Lock for qx_sq_cnt. */
#ifdef Q_XTRA
	Q_XTRA;
#endif
};

#if ((CPU_FAMILY==I960) && (defined __GNUC__))
#pragma align 0                 /* turn off alignment requirement */
#endif  /* CPU_FAMILY==I960 */

#define	q_sqh		q_osx->qx_sqh
#define	q_runq_sqe	q_osx->qx_runq_sqe
#define	q_sq_cnt	q_osx->qx_sq_cnt
#define	q_sq_cnt_lock	q_osx->qx_sq_cnt_lock

#define	F_SQE_INUSE		0x01		/* element in use */
#define	F_SQE_HOLD		0x02		/* Wants permanent control. */
#define	F_SQE_OSR_SLEEPER	0x04		/* sleep close */
#define	F_SQE_WRITER		0x08		/* Wants to be a writer. */
#define	F_SQE_NO_HISTORY 	0x10		/* Suspend sleeper history. */
#define	F_SQE_WRITER_RELEASE	0x20		/* Release after callback */

#ifndef SQH_EMPTY
#define	SQH_EMPTY(sqh)	(((SQEP)(sqh))->sqe_next == (SQEP)(sqh))
#endif

#ifndef	SQE_NEXT
#define	SQE_NEXT(sqe)	(((SQEP)(sqe))->sqe_next)
#endif

#ifndef	SQE_PREV
#define	SQE_PREV(sqe)	(((SQEP)(sqe))->sqe_prev)
#endif

#ifndef _OSR_
#include <osr.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

#ifndef	OTHER_BECOME_WRITER
extern	void	mps_become_writer(   queue_t * q, mblk_t * mp, void (*func)(PCELL, mblk_t *)   );

extern	boolean	mps_osr_writer(   queue_t * q, OSRP osr   );

extern	void	mps_writer_release(   queue_t * q, boolean turn_head   );
#endif	/* OTHER_BECOME_WRITER */

extern	boolean	mps_mult_acquire(   OSRP osr   );

extern	void	mps_mult_release(   void   );

#ifndef OTHER_MPS_SQE_INSERT_HEAD
extern	void	mps_sqe_insert_head(   SQHP sqh, SQEP sqe   );
#endif

#ifndef OTHER_MPS_SQE_INSERT_TAIL
extern	void	mps_sqe_insert_tail(   SQHP sqh, SQEP sqe   );
#endif

#ifndef OTHER_MPS_SQE_LATERAL
extern	void	mps_sqe_lateral(   PCELL arg0, mblk_t * arg1_mp, sqecb_t callback, SQHP sqh, SQEP sqe   );
#endif

#ifndef OTHER_MPS_SQE_LATERAL_HARD
extern	void	mps_sqe_lateral_hard(   PCELL arg0, mblk_t * arg1_mp, sqecb_t callback, SQHP sqh, SQEP sqe   );
#endif

#ifndef OTHER_MPS_SQE_REMOVE
extern	SQEP	mps_sqe_remove(   SQHP sqh, SQEP sqe_to_remove   );
#endif

#ifndef OTHER_MPS_SQE_REMOVE_HEAD
extern	SQEP	mps_sqe_remove_head(   SQHP sqh   );
#endif

#ifndef OTHER_MPS_SQE_RIP
extern	void	mps_sqe_rip(   queue_t * q   );
#endif

extern	void	mps_sqe_subordinate(   queue_t * q, SQHP psqh   );

#ifndef OTHER_MPS_SQE_WRAPPER
extern	void	mps_sqe_wrapper(   PCELL q_void, mblk_t * junk   );
#endif

#ifndef OTHER_MPS_SQH_ACQUIRE
extern	boolean	mps_sqh_acquire(   SQHP sqh, SQEP sqe   );
#endif

#ifndef OTHER_MPS_SQH_INIT
extern	int	mps_sqh_init(   SQHP sqh   );
#endif

#ifndef OTHER_MPS_SQH_RELEASE
extern	void	mps_sqh_release(   SQHP sqh_orig   );
#endif

extern	void	mps_sqh_turnover(   SQHP sqh   );

#ifndef OTHER_Q_RUNQ_SQE_INIT
extern	int	q_runq_sqe_init(   queue_t * q   );
#endif

#ifdef __cplusplus
};
#endif

#endif	/* _MPSSQ_ */

#endif /* __INCmpssqh */
