/* sockuser.h - Address definition header */

/* Copyright 1984-1995 Wind River Systems, Inc. */

/*
modification history
--------------------
01a,24aug95,sgv  Added copyright
*/

#ifndef __INCsockuserh
#define __INCsockuserh

#ifndef _SOCKUSER_
#define	_SOCKUSER_ 
/** Copyright (c) 1993  Mentat Inc.
 ** sockuser.h 4.1, last change 9/1/93
 **/

#ifndef WRS
static char	sockuser_h_sccsid[] = "@(#)sockuser.h	4.1";
#endif

#ifdef __cplusplus
extern "C" {
#endif

/*
 * sockuser.h -- address definitions for socklib/mod that are
 *	1 - port specific
 *	2 - may be needed by applications.
 */

#define PRIMTYPE	long		/* type used for T_primitive type field */
#define SOCKBUG		101		/* unused UNIX errno for socket bugs */
#define AFUNIXBUG	102		/* unused UNIX errno for afu bugs */
#define SOCKBADMSG	103		/* unexpect msg at stream head */

/*
 * esballoc() msg's have this "PRIM_type" in the M_PROTO part.
 */
#define	ESB_PRIMTYPE	0x45534200	/* "ESB" for debugging */

/*
 * special flag to recvfrom() when called from recvmsg().  Must
 * not conflict with other flags values.
 */
#define	MSG_FRAGMENT_DATAGRAM	0x1000

#if ((CPU_FAMILY==I960) && (defined __GNUC__))
#pragma align 1                 /* tell gcc960 not to optimize alignments */
#endif  /* CPU_FAMILY==I960 */

/*
 * sockets avoids using a union to define sockaddr, since Unix domain names
 * much longer than others.  Here union is unavoidable if sockmod is to
 * treat AF_UNIX transparently.
 *
 * "eXtended" AF_UNIX sockaddr -- includes unique dev/inode pair
 * xu_inode_flag != 0 for internally generated names with psuedo devinode[].
 *		 == 0 if devinode[] from file system stat()/fstat().
 */
struct sockaddr_xu {
	struct sockaddr_un	xu_addr;
	char			xu_devinode[10];
	};
#define XU_ADDRLEN	sizeof(struct sockaddr_xu)
#define	FAKE_INODE	64
#define xu_nullbyte	xu_devinode[0]
#define xu_inode_flag	xu_devinode[1]
#define xu_device	xu_devinode[2]
#define xu_inode	xu_devinode[6]
#define XU_DEVICE(addr)	BE32_TO_U32(&((addr).xu_device))
#define XU_INODE(addr)	BE32_TO_U32(&((addr).xu_inode))

typedef union Saddr {
		short			SA_family;
		struct sockaddr		SA_addr;
		struct sockaddr_in	SA_inaddr;
		struct sockaddr_un	SA_unaddr;
		struct sockaddr_xu	SA_xuaddr;
	} SADDR, * SADDRP;

#if ((CPU_FAMILY==I960) && (defined __GNUC__))
#pragma align 0                 /* turn off alignment requirement */
#endif  /* CPU_FAMILY==I960 */

#define MAX_UNIX_ADDR	sizeof(struct sockaddr_un)
#define SA_FAMILY_SIZE	sizeof(short)
#define MAX_UNIX_PATH	(MAX_UNIX_ADDR - SA_FAMILY_SIZE)
/*
 * following macro to simplify length argument to socket functions.
 */
#define SADDRLEN(x)	( ((x).SA_family == AF_UNIX) ? \
			MAX_UNIX_ADDR : sizeof(struct sockaddr) )
			
#ifdef __cplusplus
}
#endif
			
#endif	/* _SOCKUSER_ */

#endif /* __INCsockuserh */
