#ifndef __INCsthh
#define __INCsthh

/** Copyright (c) 1989-1994  Mentat Inc.
 ** sth.h 4.8, last change 8/31/94
 **/

#ifndef _STH_
#define _STH_

#ifndef WRS
#ifndef lint
static	char	sth_h_sccsid[] = "@(#)sth.h 4.8";
#endif
#endif /* WRS */

#ifndef _OSR_
#include <osr.h>
#endif

#define	sth_rq_empty(q)		((q)->q_first == nilp(mblk_t))

/* This is used by sth_link to create a mux identifier for a lower stream. */
#define	sth_id(sth)		((int)(sth) & ~INT_SIGN_BIT)

/*
 * Implementations that impose requirements on conditions for running OSR's
 * (such as original process context) may want to define STH_OSR_LOOP to
 * mps_osr_loop in led.h.
 */
#ifndef	STH_OSR_LOOP
#define	STH_OSR_LOOP		sth_osr_loop
#endif

#define	sth_osr_finish_err(osr,err) \
		(osr)->osr_err = (err), mps_osr_finish(osr)        

/*
 * Implementations that impose requirements on conditions for running OSR's
 * (such as original process context) may want to define STH_OSR_RESTART to
 * mps_osr_restart in led.h.
 */
#ifndef STH_OSR_RESTART
#define	STH_OSR_RESTART(osrq) \
	STH_OSR_LOOP(OSRQ_NEXT(((OSRQP)(osrq)))->osrq_osr)
#endif

/*
 * The macro decides if a queue is at the end of a stream or the
 * mid-point of a pipe.
 */
#define	STREAM_END(q)	\
	(((q)->q_flag & QWELDED) \
	||  !(q)->q_next || ((q)->q_next->q_flag & QREADR))

#define	MAX_QBAND		255
#define	MIN_CLOSE_WAIT_TIMEOUT	0
#define	READ_MODE_MASK		(RNORM|RMSGD|RMSGN|RFILL)
#define	READ_PROTO_MASK		(RPROTNORM|RPROTDAT|RPROTDIS)
#define	READ_OPTIONS_MASK	(READ_MODE_MASK|READ_PROTO_MASK)

/* STH flags */
#define F_STH_READ_ERROR	0x1	/* M_ERROR rcv'd, fail all reads */
#define	F_STH_WRITE_ERROR	0x2	/* M_ERROR rcv'd, fail all writes */
#define	F_STH_HANGUP		0x4	/* M_HANGUP rcv'd, no more data */
#define	F_STH_CLOSE_WAIT	0x8	/* closing, waiting for WQ to drain */
#define	F_STH_CLOSED		0x10	/* fd closed, unlink should free */
#define	F_STH_LINKED		0x20	/* stream head linked lower stream */
#define	F_STH_READ_WAIT		0x40
#define	F_STH_WRITE_WAIT	0x80
#define	F_STH_IOCTL_WAIT	0x100
#define	F_STH_CLOSING		0x200	/* actively on the way down */
#define	F_STH_IOCTL_RESTART	0x400	/* need deferred ioctl q processing */
#define	F_STH_WRITE_RESTART	0x800	/* need deferred write q processing */
#define	F_STH_MREADON		0x1000	/* gen M_READ messages */
#define	F_STH_READ_RESTART	0x2000	/* need deferred read q processing */
#define	F_STH_TTY_ONDELAY	0x8000	/* TTY semantics on O_NDELAY  */
#define	F_STH_TOSTOP		0x10000	/* disallow bg writes (job control) */
#define	F_STH_PIPE		0x20000	/* A pipe */
#define	F_STH_FIFO		0x40000	/* A FIFO */
#define	F_STH_PGRP_SET		0x80000 /* SIOCSPGRP or TIOCSPGRP in effect */
#define	F_STH_IS_TTY		0x100000/* This stream is a tty */
#define	F_STH_CTTY		0x200000/* This stream is a controlling tty */

#define	STH_HASH_LENGTH		128

#if ((CPU_FAMILY==I960) && (defined __GNUC__))
#pragma align 1                 /* tell gcc960 not to optimize alignments */
#endif  /* CPU_FAMILY==I960 */

#ifndef OTHER_MPS_IR_TABLE
/*
 * Structure of ioctl request table (ir_tbl).  There is one such table on
 * a system.
 */
typedef struct ir_s {
	int		ir_cmd;		/* command */
	OSR_STATUS	(*ir_pfi)(OSRP); /* routine to call */
	int		ir_queue_indx;	/* Which OSR queue to use */
} IR;
#endif

/*
 * Structure linked into the STH for each pending poll request.
 * The structure is allocated when the request is made and only exists
 * during the life of the poll.
 */
typedef struct polls_s {
	struct polls_s	* ps_sth_link;	/* Link to next POLLS */
	struct sth_s	* ps_sth;	/* Backpointer for poll's use */
	OSRP		ps_osr;		/* OSR to restart on an event */
	unsigned short	ps_events;	/* Events to look for */
	unsigned short	ps_revents;	/* events that hit while waiting */
	unsigned short	ps_flags;
} POLLS, * POLLSP;

#define	F_POLL_BADF		0x1	/* this stream has been closed */

/*
 * Control structure linked into the STH for signals.  One such structure
 * is created for each process accessing a stream that has requested signals
 * with an I_SETSIG request.  The structure lives until the process clears
 * the signal setting or the stream is closed.
 */
typedef	struct sigs_s {
	struct sigs_s	* ss_link;	/* Link to next SIGS structure */
	ulong	ss_procid;		/* Process identifier */
	uint	ss_mask;		/* Events that should be signalled  */
#ifdef SIGS_XTRA
	SIGS_XTRA
#endif
} SIGS, * SIGSP;

/*
 * These flags live in the upper bits of ss_mask; they must not
 * overlap with the normal signal bits defined in stropts.h.
 */
#define	F_SIGS_SIGIO	0x8000		/* Send SIGIO, not SIGPOLL */
#define	F_SIGS_PGRP	0x4000		/* Send to process group */

/*
 * Stream head control structure.  One structure is created for
 * each open stream.  The structure is freed only when the stream
 * is closed.
 */
typedef struct sth_s {
	queue_t	* sth_rq;		/* Stream head read queue */
#ifndef	MPS_SVR4_REPLACEMENT
	queue_t	* sth_wq;		/* Stream head write queue */
	int	sth_read_error;		/* Read-side error, if any */
	int	sth_write_error;	/* Write-side error, if any */
	u32	sth_flags;		/* See flags above */
#else
#define	sth_wq		sth_sd.sd_wrq
#define	sth_read_error	sth_sd.sd_rerror
#define	sth_write_error	sth_sd.sd_werror
#define	sth_flags	sth_sd.sd_flag
#endif
	int	sth_read_mode;		/* Byte-stream, msg discard, etc. */
	int	sth_write_mode;		/* SNDZERO, SNDPIPE, etc. */
	int	sth_close_wait_timeout;	/* ms to wait for drain in close */
	dev_t	sth_dev;		/* Device number of stream */
	int	sth_npush;
	SIGSP	sth_sigs;		/* Events to be signalled */
	int	sth_ioc_id;		/* id (!=0) of outstanding M_IOCTL */
	mblk_t	* sth_ioc_mp;		/* M_IOCACK or M_IOCNAK reply */
	/* NOTE: these queues must be quad-word aligned for VMS */
	OSRQ	sth_osr_q_arr[3];
#define	IOCTL_OSR_Q	0
#define	READ_OSR_Q	1
#define	WRITE_OSR_Q	2
#define	sth_ioc_osr_q	sth_osr_q_arr[IOCTL_OSR_Q]
#define	sth_read_osr_q	sth_osr_q_arr[READ_OSR_Q]
#define	sth_write_osr_q	sth_osr_q_arr[WRITE_OSR_Q]
	ulong	sth_wroff;		/* Write offset for write and putmsg */
	int	sth_pollevents;		/* Summary of requested poll events */
	POLLSP	sth_polls;		/* Outstanding polls on the stream */
	int	sth_muxid;		/* mux id, if linked under a mux */
	struct sth_s	* sth_mux_link;	/* link to next muxed lower stream */
	struct sth_s	* sth_mux_top;	/* controlling mux list */
	struct sth_s	* sth_pmux_top;	/* controlling mux list for plinks */
	mblk_t	* sth_ioc_timer_mp;
	struct sth_s	* sth_next;	/* next STH on sth_open_streams list */
	queue_t	* sth_dev_wq;		/* Saved device for Streams pipes */
	u32	sth_poll_set;		/* Poll events always on */
	u32	sth_poll_clr;		/* Poll events always off */
#ifdef STH_XTRA
	STH_XTRA			/* Extra space for port-specific needs.*/
#endif
} STH, * STHP, ** STHPP;

/* MPS statistics structure. */
typedef struct mps_stat_s {
	int	stt_alloc;	/* Currently existant. */
	int	stt_inuse;	/* Currently in use. */
	int	stt_total;	/* Total ever allocated. */
	int	stt_max;	/* Maximum ever in use. */
	int	stt_fail;	/* Allocation failures. */
} mps_stat_t;

#if ((CPU_FAMILY==I960) && (defined __GNUC__))
#pragma align 0                 /* turn off alignment requirement */
#endif  /* CPU_FAMILY==I960 */

#ifdef __cplusplus
extern "C" {
#endif

extern	int	nstrpush;

extern	queue_t * allocq(   void   );

extern	int	freeq(   queue_t * q   );

extern	void	sth_deliver_msig(   STHP sth, mblk_t * mp   );

extern	void	sth_err_wakeup(   STHP sth, int sig_mask, int poll_event   );

extern	mblk_t	* sth_getq(   STHP sth   );

extern	int	sth_iinit(   void   );

extern	OSR_STATUS	sth_osr_read(   OSRP osr   );

extern	void	sth_iocdata(   STHP sth, mblk_t * mp, int rval   );

extern	OSR_STATUS	sth_ipop(   OSRP osr, queue_t * q   );

extern	OSR_STATUS	sth_osr_cancel(   OSRP osr   );

extern	int	sth_cancel_sigs(   STH * sth, uint procid   );

extern	OSR_STATUS	sth_osr_close(   OSRP osr   );

#ifndef OTHER_MPS_IR_TABLE
extern	void	sth_osr_ioctl(   PCELL osr_pcell, mblk_t * junk   );
#endif

extern	void	sth_osr_loop(   OSRP osr   );

extern	void	sth_osr_middle(   PCELL osr_pcell, mblk_t * junk   );

extern	OSR_STATUS	sth_osr_open(   OSRP osr   );

#ifndef	OTHER_STH_OSR_SQE_CALLBACK
extern	void	sth_osr_sqe_callback(   PCELL osr_pcell, mblk_t * junk   );
#endif

extern	int	sth_rput(   queue_t * q, mblk_t * mp   );

extern	void	sth_set_queue(   queue_t  * q, struct qinit * rinit, struct qinit * winit   );

extern	void	sth_sigpoll_wakeup(   STHP sth, int sig_mask, int poll_event   );

extern	boolean	sth_slp_alloc(   OSRP osr   );

extern	void	sth_slp_free(   OSRP osr   );

#ifndef MPS_NO_UNLOAD
extern	int	sth_unload(   void   );
#endif

extern	OSR_STATUS	sth_osr_write(   OSRP osr   );

#ifdef MPS_DEBUG
extern	int	sth_dump_hash(   char * msg   );

extern	int	sth_show_str(   STHP sth, char * msg   );
#endif

#ifdef __cplusplus
};
#endif

#endif	/* _STH_ */

#endif /* __INCsthh */
