/* Copyright 1990-1992 Wind River Systems, Inc. */
/*
modification history
-------------------------
01a,30jun97,rjc added pragma align stuff
*/

#ifndef __INCos_intfh
#define __INCos_intfh

/******************************************
os_intf.h

OSPF definitions related to interface state
machine.


copyright phase2 networks inc, 1994
all rights reserved

SID: 1.3
Revision History:


    1.3	95/11/27 13:37:08 root
	multiple incarnation support

    1.2	95/05/02 14:19:14 root
	add tos

    1.1	94/12/04 09:38:18 root
	date and time created 94/12/04 09:38:18 by root

******************************************/
#ifndef OSPF_INTERFACE_H
#define OSPF_INTERFACE_H 1


/* Extract the equivalent of the Hello Packet E option
 * from our area
 * The result MUST BE 0 or 1, because we compare for equality
 * with the hello packet result
 */
#define AREA_E_OPTION(area) (!(area)->a_stub)

#define INTF_AREA_ID(intf) ((intf)->c_area->a_id)
#define RT_ID_GREATER(rtid1, rtid2) ( n2u32(&(rtid1))>n2u32(&(rtid2)) )
#define MY_RTR_PRIORITY(intf) ((intf)->c_rtrpri)
#define MY_IPA(intf) ((intf)->c_ipaddr.ip_add)

#define CIRC_E_OPTION(circ) (AREA_E_OPTION(circ->c_area)<<1)
#define CIRC_T_OPTION(circ) (ospfNode->n_tos?1:0)

#define NEIGHBOR_CHANGED(intf) do{if(intf->c_drstate > CIRC_IPTPT)\
	ospfScheduleDR(intf);}while(0)

#endif /* ospf_interface.h */
#endif /* __INCos_intfh */
