/* Copyright 1990-1992 Wind River Systems, Inc. */
/*
modification history
-------------------------
01a,30jun97,rjc added pragma align stuff
*/

#ifndef __INCos_protoh
#define __INCos_protoh

/**************************************************
os_proto.h

OSPF function prototypes


copyright phase2 networks inc, 1994
all rights reserved

SID: 1.11
Revision History:


    1.11	96/04/17 11:21:05 root
	mod vcirccreate for snmp test

    1.10	96/02/06 22:30:17 root
	extern api mods

    1.9	96/01/10 08:35:13 root
	ospfAddExtRt added tag param

    1.8	95/11/09 09:45:23 root
	add mospf

    1.7	95/10/23 23:12:35 root
	use cmn link fcns

    1.6	95/10/03 14:31:05 root
	add auto param to vccreate

    1.5	95/06/22 08:57:48 root
	add settest

    1.4	95/05/02 14:19:32 root
	add tos

    1.3	95/03/13 09:19:22 root
	added lsalink

    1.2	95/01/02 17:42:49 root
	final test

    1.1	94/12/04 09:38:33 root
	date and time created 94/12/04 09:38:33 by root

**************************************************/

fnc_prot(word, ospfIpcsum,(word*,int,word))
fnc_prot(void,ospfLsaLink,(lsai_pt,dll_pt))
fnc_prot(void, ospfPentULink,(pathent_pt,dll_pt))
fnc_prot(void, ospfPentLink,(pathent_pt,dll_pt))
fnc_prot(void, ospfASPULink,(rl_lsai_pt))
fnc_prot(void, ospfASPLink,(rl_lsai_pt))
fnc_prot(int,  ospfLsaSortCmp,(lsai_pt,lsai_pt))
fnc_prot(void, ospfLsaSortLink,(lsai_pt,area_pt))
fnc_prot(void, ospfLsaSortULink,(lsai_pt,area_pt))
fnc_prot(void, ospfCircMoveArea,(os_circ_pt,area_pt,area_pt))
fnc_prot(void, ospfDoAreaCheck,(void))
fnc_prot(cfg_range_pt,  ospfFindRange, (area_pt, ipna_pt,int))
fnc_prot(area_pt, ospfAreaFromId,(ipa))
fnc_prot(int,  ospfContain,(ipna_pt,ipna_pt))

fnc_prot(void, ospfSpfIntra,(area_pt))
fnc_prot(void, ospfSpfInter,(area_pt,int))
fnc_prot(void, ospfSpfExtern,(int))
fnc_prot(lsai_pt, ospfFindLsai,(area_pt,dword,dword,int))
fnc_prot(lsai_pt, ospfFindNextLsai,(area_pt,dword,dword,int,int))
fnc_prot(lsai_pt, ospfAddLsai,( lsa_pt,area_pt ))
fnc_prot(void, ospfClrRlPath, (area_pt))
fnc_prot(void, ospfPeInit,(void))
fnc_prot(void, ospfStartRtHash,(int,int,ipa))
fnc_prot(void, ospfEndRtHash,(int,int,ipa))
fnc_prot(int , ospfAddASPath,(pathent_pt))
fnc_prot(int, ospfModASPath,(pathent_pt))
fnc_prot(void, ospfPurgeASPath,(area_pt,int))
fnc_prot(void, ospfUpdateRtl1,(void))
fnc_prot(void, ospfUpdateRtl2,(void))
fnc_prot(void, ospfUpdateRtl3,(void))
fnc_prot(void, ospfAdjUpdate,(void))
fnc_prot(void, ospfChkSpf,(void))
fnc_prot(void, ospfClrLeakUse,(int))
fnc_prot(void, ospfLeak,(pathent_pt,area_pt,int))
fnc_prot(void, ospfModLeak,(pathent_pt))
fnc_prot(void, ospfUpdateSumm,(void))
fnc_prot(void, ospfUpdateVlink,(pathent_pt,area_pt))
fnc_prot(void, ospfTransitAdj,(void))
fnc_prot(void, ospfChkVlink, (area_pt))
fnc_prot(os_circ_pt, ospfFindPtPtCirc,(ipa,area_pt))

fnc_prot(int, ospfProcLsa,(lsa_pt,area_pt,nbr_pt))
fnc_prot(void, ospfLsaReqDelOlder,(lsa_pt,nbr_pt))
fnc_prot(lsai_pt, ospfAddLsa,(lsa_pt))
fnc_prot(void, ospfLsaFlush,(lsai_pt))
fnc_prot(void, ospfLsaBumpSelf,(lsai_pt,sdword))
fnc_prot(int , ospfUpdateLsai,(lsai_pt,lsa_pt))
fnc_prot(int, ospfLsaRTXDel,(lsai_pt,nbr_pt))
fnc_prot(void, ospfLsaiReclaim,(lsai_pt lsai))
fnc_prot(int , ospfFlood, (lsai_pt,nbr_pt))
fnc_prot(dword, ospfTimestamp, (void))
fnc_prot(int, ospfLsaAgeCmp, (lsa_pt,lsai_pt))
fnc_prot(int, ospfLsaReqAgeCmp, (lsr_pt,lsai_pt))
fnc_prot(int, ospfVerLsaCsum, (lsa_pt))
fnc_prot(void,ospfGenLsaCsum, (lsa_pt))
fnc_prot(void, ospfDeleteLsai,(lsai_pt))
fnc_prot(void, ospfLsaTimeout,(lsai_pt))
fnc_prot(void, ospfLsaRefresh,(lsai_pt))
fnc_prot(void, ospfBuildMyLsd, (area_pt))
fnc_prot(void, ospfBuildMyNetlinks, (os_circ_pt))
fnc_prot(void, ospfBuildASELink, (ase_hdr_pt))
fnc_prot(void, ospfBuildSummLinks, (summ_hdr_pt))
fnc_prot(void, ospfBuild1SummLink, (summ_hdr_pt,area_pt))
fnc_prot(void, ospfBuildDefSummLink, (area_pt))
fnc_prot(summ_hdr_pt, ospfLsai2Summ,(lsai_pt))
fnc_prot(ase_hdr_pt,  ospfLsai2Ase, (lsai_pt))
fnc_prot(void, ospfLsaOwnPurge, (lsai_pt,int))
fnc_prot(int,  ospfChkRebuild, (lsai_pt))

fnc_prot(os_circ_pt, ospfVCircFromRtid,(area_pt,ipa))
fnc_prot(void, ospfVCEvent,(int,os_circ_pt))
fnc_prot(area_pt, ospfIpa2Area, ( ipna_pt))
fnc_prot(os_circ_pt, ospfCircFromIf,(void *))
fnc_prot(os_circ_pt, ospfCircFromIpa,(ipa, area_pt))
fnc_prot(void, ospfRunSpf,(void))
fnc_prot(int,  ospfHasVlink,(area_pt))

fnc_prot(otimer_pt,ospfTimerCreate,(vfcnptr,void *,int,int))
fnc_prot(void, ospfTimerDelete,(otimer_pt))
fnc_prot(void, ospfTimerSet,(otimer_pt,int,vfcnptr))
fnc_prot(void, ospfTimerDisable, (otimer_pt))
fnc_prot(void, ospfProcTimers,(void))

fnc_prot(void *, ospfGetPtptIFID,(int,int *,int))
fnc_prot(void *, o_gen_find,(void))
fnc_prot(area_pt, o_area_find,(void))
fnc_prot(area_pt, o_stub_find,(void))
fnc_prot(lsai_pt, o_lsdb_find,(void))
fnc_prot(cfg_range_pt, o_range_find,(void))
fnc_prot(HOST_RT *, o_host_find,(void))
fnc_prot(os_circ_pt, o_intf_find,(void))
fnc_prot(os_circ_pt, o_metric_find,(void))
fnc_prot(os_circ_pt, o_vintf_find,(void))
fnc_prot(nbr_pt, o_nbr_find,(void))
fnc_prot(nbr_pt, o_vnbr_find,(void))


fnc_prot(void,dd_packet_resend,(Neighbor *neighbor ))
fnc_prot(Neighbor,*ospfCreateNewNeighbor,( OS_CIRC *, ipa , ospf_packet *))

fnc_prot( void, ospfProcLSR,(ospf_packet *, OS_CIRC *, Neighbor *))
fnc_prot( void, ospfProcLSU,(ospf_packet *, OS_CIRC *, Neighbor *))
fnc_prot( int, ospfOnNbrReqList,(lsa_pt, Neighbor *))
fnc_prot( void, ospfProcLSAck,(ospf_packet *, OS_CIRC *, Neighbor *))
fnc_prot(void, ospfCheckDelayedAck,(void))

fnc_prot(void,ospfScheduleDR,(os_circ_pt interface))

fnc_prot(DB_packet *, ospf_init_db_packet,(void))


fnc_prot(void, ospfHelloTimerFunc,(os_circ_pt interface))
fnc_prot(void, ospfNbmaTransmit,(os_circ_pt,ibd_pt,int,int))
fnc_prot(void , ospf_do_adj_ok, (Neighbor *neighbor))
fnc_prot(void , ospf_extract_auth, (ospf_packet *packet, authkey_t *key))
fnc_prot(void , ospf_do_two_way, (Neighbor *neighbor))
fnc_prot(void , ospf_do_bad_ls_req, (Neighbor *neighbor))
fnc_prot(void , ospf_acknowledge_duplicate_db_desc_packet, (Neighbor *))
fnc_prot(void , ospf_do_exchange_done, (Neighbor *neighbor))
fnc_prot(void, ospf_do_negotiation_done,(Neighbor *neighbor))
fnc_prot(void , SendDDPacket, (Neighbor *neighbor,int))
fnc_prot(void , ospf_do_hello_received, (Neighbor *neighbor))
fnc_prot(void , ospf_do_one_way, (Neighbor *neighbor))
fnc_prot(void, ospf_do_loading_done,(Neighbor *))
fnc_prot(void, ospf_do_kill_nbr,(Neighbor *))
fnc_prot(void , ospf_circ_is_up, (os_circ_pt interface))
fnc_prot(void , ospf_circ_is_down, (os_circ_pt interface))
fnc_prot(int , ospfSendHelloPacket, (os_circ_pt circuit, ipa dst))
fnc_prot(int , ospfSendEmptyHello, (os_circ_pt circuit))
fnc_prot(int , ospfCopyDBSummary, (Neighbor *neighbor))
fnc_prot(void , ospfSendNextLSReq, (Neighbor *neighbor))
fnc_prot(void, ospfSendNextDbRequest,(Neighbor *,db_req_pt))
fnc_prot(void, ospfNeighborRetransmit,(Neighbor *nbr))
fnc_prot(void , ospf_insert_auth, (ospf_packet *packet, os_circ_pt circuit))
fnc_prot(void , ospfAddToRetransList, (Neighbor *neighbor, lsai_pt lsai))
fnc_prot(void, ospfRetransDel,(retrans_pt rtx, Neighbor *nbr))
fnc_prot(void , ospfActuallySendPacket, (Neighbor *neighbor, DB_packet* packet))
fnc_prot(ibd_pt, ospfCreateLSUPacket,(lsai_pt , int ,  os_circ_pt ))
fnc_prot(void, ospfFinishLSUPacket,(ospf_packet *, int , int , os_circ_pt ))
fnc_prot(void, ospf_header,(word size, byte type, ospf_packet *packet, os_circ_pt circuit))
fnc_prot(void, ospfAddToReqList, (db_req *new_list, Neighbor* neighbor))
fnc_prot(void, ospfCheckDR,(void))
fnc_prot(void, ospfSetRxmtTimer,(Neighbor *neighbor))
#if 0
fnc_prot(void, ospf_db_packet_free,(DB_packet*))
#endif
fnc_prot(char *, ospf_packet_type,(ospf_packet*))

/****************************
internal struct version of api
****************************/
fnc_prot(os_circ_pt, ospfCircCreate,(int,void *,ipna_pt,dword))
fnc_prot(os_circ_pt, ospfVCircCreate,(area_pt,ipa,int,int))
fnc_prot(int, ospfCircDelete,(os_circ_pt))
fnc_prot(nbma_dst_pt, ospfAddNbmaDst,(ipa,void *,int))
fnc_prot(void ,ospf_receive,(ospf_packet *, int, void *, ipa, ipa))

/***********************************************
port specific protos
***********************************************/
fnc_prot(ibd_pt, ospf_oframe_alloc,(int))
fnc_prot(void, ospf_oframe_free,(ibd_pt))

#endif /* __INCos_protoh */
