/* Copyright 1990-1992 Wind River Systems, Inc. */
/*
modification history
-------------------------
01a,30jun97,rjc added pragma align stuff
*/

#ifndef __INCos_spexth
#define __INCos_spexth

/***********************************************
os_spext.h:

spf decision process definitions visible external
to the engine

copyright phase2 networks 1994
all rights reserved

SID: 1.1
Revision History:


    1.1	96/02/06 22:28:35 root
	date and time created 96/02/06 22:28:35 by root

************************************************/

#if ((CPU_FAMILY==I960) && (defined __GNUC__))
#pragma align 1                 /* tell gcc960 not to optimize alignments */
#endif  /* CPU_FAMILY==I960 */

/* storage of router VEB bits that goes with 
   a path entry for router paths
*/
struct rtrdest{
	ipa 			ipaddr;		/* i/f addr of rtr */
	unsigned char 	flags;		/* VEB bits */
}; 

/* one forward nexthop/cost per TOS */
typedef struct osnh{
	unsigned char		pe_numnh;
	unsigned long		pe_cost;		/* ospf cost */
						/* possbile nexthops */
	ipa				pe_nh[MAX_MSPLIT];
#ifdef OSPF_IN_ENGINE
	/* engine internally needs this, but external
	   view does not
	*/
	struct circuit		*pe_nc[MAX_MSPLIT];
#else
	void				*pe_nc[MAX_MSPLIT];
#endif
}OSNH;
#if ALL_METRICS
#define NUM_OSNH  5
/* 
index:
0 default
1 monetary cost
2 reliability
3 throughput
4 delay
*/
#else
#define NUM_OSNH  1
#endif

/* structs used for storing tent and paths entries */
typedef struct path_entry{

	struct path_entry 	*pe_fwd;			/* links */
	struct path_entry	*pe_bwd;
	unsigned long		pe_vid;		/* vertex ID */
#ifdef OSPF_IN_ENGINE
	/* engine internally needs this, but external
	   view does not
	*/
	struct lsa_info	*pe_lsai;		/* lsa of origin */
#else
	void				*pe_lsai;
#endif
	union{
	  struct ipnetaddr	pe_ipa;		/* dest net/mask */
	  struct rtrdest	pe_rd;		/* rtr VEB bits */
	}u;
	unsigned char		pe_type;
#if P2_MOSPF
	unsigned char		pe_iltype;	/* incoming link */
	unsigned char		pe_ttl;
	struct path_entry	*pe_parent;	/* upstream node */
#endif
	unsigned long		pe_cost2;		/* ext type2 cost*/
	unsigned long		pe_tag;		/* for as ext */
	OSNH				t[NUM_OSNH];	/* hops by tos */
}PATHENT, *pathent_pt;

#if ((CPU_FAMILY==I960) && (defined __GNUC__))
#pragma align 0                 /* turn off alignment requirement */
#endif  /* CPU_FAMILY==I960 */

/* Path Entry Types (spf vertex types ) */
#define PENT_RTR		1		/* transit router */
#define PENT_TRNET		2		/* transit net */
#define PENT_STNET		3		/* stub net */
#define PENT_ABR		4		/* area bdr rtr */
#define PENT_ASBR		5		/* as bdr rtr */
#define PENT_SUMNET		6		/* net summary */
#define PENT_SUMASB		7		/* asbdr summary */
#define PENT_EXTRT		8		/* external type1 or2*/

/* is a transit vertex ? */
#define PENT_TRANSIT(xp)  (xp->pe_type == PENT_RTR || \
					  xp->pe_type == PENT_TRNET) 

#endif /* __INCos_spexth */
