/* Copyright 1990-1992 Wind River Systems, Inc. */
/*
modification history
-------------------------
01a,30jun97,rjc added pragma align stuff
*/

#ifndef __INCp2fwdh 
#define __INCp2fwdh

/***********************************************
fwd.h:

forwarding entry definition

copyright phase2 networks 1991
all rights reserved

SID: 1.7
Revision History:


    1.7	95/06/23 15:10:54 root
	make cmn

    1.6	95/04/18 09:21:16 root
	cid all int

    1.5	94/02/25 16:32:07 root
	ifndef file for decnet coexistence

    1.4	93/05/05 16:25:11 root
	nop

    1.3	93/04/22 09:28:45 root
	

    1.2	93/04/15 16:46:49 root
	multi-prot enhancements

    1.1	92/09/15 14:55:46 root
	date and time created 92/09/15 14:55:46 by root

************************************************/
#ifndef _fwd_h
#define _fwd_h

#if ((CPU_FAMILY==I960) && (defined __GNUC__))
#pragma align 1                 /* tell gcc960 not to optimize alignments */
#endif  /* CPU_FAMILY==I960 */

/* a forwarding destination */
typedef struct fwdent{
	struct sn_addr	fe_addr;		/* next hop addr */
	int 			fe_cid;		/* output circ id */
#if PDU_CNVT
	word			fe_cnvt;		/* conversion flags */
#endif /* PDU_CNVT */
}fent, *fent_pt;

#if ((CPU_FAMILY==I960) && (defined __GNUC__))
#pragma align 0                 /* turn off alignment requirement */
#endif  /* CPU_FAMILY==I960 */

/* means no route */
#define INVALID_CIRC	-1

/* this is a way to locate an adjacency from a fent */
#define FE_ADJ(fe)	(adj_pt)((byte *)fe - ( (byte *)&((adj_pt)fe)->adj_fe - (byte *)fe ))

/* conversion/encapsulation function flags */
#define CVT_P4		0x0001	/* convert to decnet phase4 */


/* this is a way to locate an atalk arp ent from a fent */
#define FE_ARP(fe)	(aarpent_pt)((byte *)fe - ( (byte *)&((aarpent_pt)fe)->ae_fent - (byte *)fe ))

#endif /*_fwd_h */

#endif /* __INCp2fwdh */
