/* Copyright 1990-1992 Wind River Systems, Inc. */
/*
modification history
-------------------------
01a,30jun97,rjc added pragma align stuff
*/

#ifndef __INCp2porth
#define __INCp2porth

/* p2port.h */


/*
modification history
-------------------------
01c,24apr97,rjc corrected macro definitions
01b,14apr97,rjc changed ASSERT macro define
01a,05dec96,rjc written
*/


/******************************************
p2port.h

porting definitions for phase2 common code

copyright phase2 networks 1995
all rights reserved


SID: 1.7
Revision History:


    1.7	96/02/13 16:54:52 root
	take out DOS #def

    1.6	96/02/08 11:14:58 root
	mod uxx_2n macros

    1.5	96/02/06 22:41:03 root
	add INIT_FAIL_ASSERT, mod s32_2n

    1.4	95/10/23 13:28:04 root
	fix uns_xx macro paren problem 

    1.3	95/10/06 16:23:34 root
	if ndef

    1.2	95/10/02 09:24:25 root
	add unswap macros

    1.1	95/09/25 17:13:37 root
	date and time created 95/09/25 17:13:37 by root

******************************************/

#ifndef _p2port_h
#define _p2port_h


#include <string.h>
#include <vxWorks.h>
#include <stdio.h>
#include <stdlib.h>

void *   ospfMalloc (int );
void    ospfFree (void *);

#define p2TimerAlloc(xlen)	ospfMalloc(xlen)
#define p2TimerFree(xpt)        ospfFree(xpt)

/* function prototyping. use fnc_prot(a,c,b) a b() if your
   compiler doesn't support prototypes
   a=return value
   b=function name
   c=argument list
*/

/* prototype version */
#define PROTO 1
#define fnc_prot(a,b,c) a b c;

/* non-prototype version */
/*
#define PROTO 0
#define fnc_prot(a,b,c) a b();
*/

extern int ospfTrace;
#define ASSERT(x,y) if (ospfTrace && (x)) { printf (y); printf ("\n"); }

/* true if assert on cannot initialize. if 0,
   protocol init returns -1 on init fail.
*/
#define INIT_FAIL_ASSERT	1

/* NOTE: this mem copy assumes a 0 len copy is valid !!! */
#define p2CopyMem(xdst,xsrc,xlen)  memcpy((byte *)(xdst),(byte *)(xsrc),xlen)

#define p2FillMem(xdst,xdata,xlen)   memset((byte *)xdst,xdata,xlen) /*fill */

#define p2CmpMem(xdst,xsrc,xlen)  memcmp((byte *)(xdst),(byte *)(xsrc),xlen)


#define u16_2n(add,val)  {*(byte *)(add)=(byte )(((val) >>8) & 0xff); \
		*((byte *)(add) +1)=(byte )((val) & 0xff);}

/* used for metrics */
#define u24_2n(add,val)  { (val) &= 0x00ffffff; \
	*((byte *)(add) +0)=(byte )(((val) >>16)&0xff); \
	*((byte *)(add) +1)=(byte )(((val) >> 8)&0xff); \
	*((byte *)(add) +2)=(byte )((val) &0xff);}

#define u32_2n(add,val)  {*(byte *)(add)=(byte )(((val) >>24)&0xff); \
	*((byte *)(add) +1)=(byte )(((val) >>16)&0xff); \
	*((byte *)(add) +2)=(byte )(((val) >> 8)&0xff); \
	*((byte *)(add) +3)=(byte )((val) &0xff);}

/*
#define u16_2n(add,val) { *(word *)(add) = (val); }
#define u32_2n(add,val) { *(dword *)(add) = (val); }
*/

#define s32_2n(add,val) u32_2n(add,((dword)(val)) )

#define n2u16(add)	((((*(byte *)(add)) <<8)&0xff00) |\
	(*((byte *)(add) +1)))

/* used for metrics */
#define n2u24(add)	(   \
	(( (dword)*((byte *)(add)   )<<16)&0xff0000) |\
	(( (dword)*((byte *)(add) +1)<<8)&0xff00) |\
	(  (dword)*((byte *)(add) +2))  )

#define n2u32(add)	( ((  ((dword)*((byte *)add)) <<24)&0xff000000) |\
	(( (dword)*((byte *)(add) +1)<<16)&0xff0000) |\
	(( (dword)*((byte *)(add) +2)<<8)&0xff00) |\
	(  (dword)*((byte *)(add) +3))  )

#define n2s32(add)	( ((  ((sdword)*((byte *)add)) <<24)&0xff000000) |\
	(( (sdword)*((byte *)(add) +1)<<16)&0xff0000) |\
	(( (sdword)*((byte *)(add) +2)<<8)&0xff00) |\
	(  (sdword)*((byte *)(add) +3))  )

#define SWAP32(val)	( (dword)((val & 0xff) << 24) |\
				  (dword)((val & 0xff00) << 8) |\
				  (dword)((val & 0xff0000) >> 8) |\
				  (dword)((val & 0xff000000) >> 24) )

/*
#define n2u16(add)  *(word *)(add )
#define n2u32(add)  *(dword *)(add )
#define n2s32(add)  *(sdword *)(add )
#define SWAP32(val)		(val)
*/

/* non-swap short/long macros for use by platforms
   that have alignment restrictions, eg 68000.
*/
/* no alignment restrictions case */

/* We go in for the restricted alignment case in general 
   rjc oct-96
 */ 

#define uns_l2p( xpdua, xnet ) {\
	*(dword *)(xpdua) = xnet; \
}
#define uns_s2p( xpdua, xw ) {\
	*(word *)(xpdua) = xw; \
}
#define uns_p2l( xpdua )	*(dword *)(xpdua)
#define uns_p2s(xw)			*(word *)(xw)

#if 0
#ifdef _BIG_ENDIAN

/* big endian ordering, restricted alignment case */
#define uns_l2p( xpdua, xnet ) u32_2n( xpdua, xnet )
#define uns_s2p( xpdua, xw )   u16_2n( xpdua, xnet )
#define uns_p2l( xpdua )	      n2u32( xpdua )
#define uns_p2s(xw)            n2u16( xpdua )

#else /* _BIG_ENDIAN not */

/* little endian ordering, restricted alignment case */
#define uns_l2p(add,val)  {*(byte *)(add)=(val)&0xff; \
	*((byte *)(add) +1)=((val) >> 8)&0xff; \
	*((byte *)(add) +2)=((val) >> 16)&0xff; \
	*((byte *)(add) +3)=((val) >> 24 )&0xff;}

#define uns_s2p(add,val)  {*(byte *)(add)=(val) & 0xff; \
		*((byte *)(add) +1)=((val)>>8) & 0xff;}

#define uns_p2l(add)	( ((  ((dword)*((byte *)(add)+3)) <<24)&0xff000000) |\
	(( (dword)*((byte *)(add) +2)<<16)&0xff0000) |\
	(( (dword)*((byte *)(add) +1)<<8)&0xff00) |\
	(  (dword)*((byte *)(add) +0))  )

#define uns_p2s(add)	((((*(byte *)(add)) <<8)&0xff00) |\
	(*((byte *)(add) +1)))

#endif /* BIG_ENDIAN */
#endif

#endif /* p2port_h */

#endif /* __INCp2porth */
