/** Copyright (c) 1988-1994  Mentat Inc.
 ** miecho.h 4.1, last change 4/11/94
 **/

#ifndef __INCmiechoh
#define __INCmiechoh

#ifndef _MIECHO_
#define _MIECHO_

#ifndef WRS
#ifndef lint
static	char	miecho_h_sccsid[] = "@(#)miecho.h 4.1";
#endif
#endif

/* Ioctl commands accepted by echo. */

#ifndef _MIIOCCOM_
#include <miioccom.h>
#endif
#define	ECHO_IOCACK		MIOC_CMD(MIOC_ECHO,1)	/* Do an iocack reply with no data */
#define	ECHO_IOCNAK		MIOC_CMD(MIOC_ECHO,2)	/* Do an iocnak reply */
#define	ECHO_NOREPLY		MIOC_CMD(MIOC_ECHO,3)	/* Let the ioctl timeout, no reply */
#define	ECHO_DATA		MIOC_CMD(MIOC_ECHO,4)	/* Do an iocack with data */
#define	ECHO_BIGDATA		MIOC_CMD(MIOC_ECHO,5)	/* Do an iocack with > ic_len data */
#define	ECHO_GENMSG		MIOC_CMD(MIOC_ECHO,6)	/* Gen a message from the eblks in data */
#define	ECHO_GENMSG_NOREPLY	MIOC_CMD(MIOC_ECHO,7)	/* Gen a message from the eblks, but don't reply to the M_IOCTL */
#define	ECHO_FEED_ME		MIOC_CMD(MIOC_ECHO,8)	/* Send infinite messages upstream. */
#define	ECHO_SETQ	MIOC_CMD(MIOC_ECHO,9)	/* Set qmin/maxpsz, qhi/lowat */
#define	ECHO_GETQ	MIOC_CMD(MIOC_ECHO,10)	/* Get qmin/maxpsz, qhi/lowat */

#define	ECHO_RVAL		0x100		/* Add return value */
#define	ECHO_RERROR		0x200		/* Error return */

#if ((CPU_FAMILY==I960) && (defined __GNUC__))
#pragma align 1                 /* tell gcc960 not to optimize alignments */
#endif  /* CPU_FAMILY==I960 */

/* Structure passed in with ioctl requests. */
typedef struct iecho_s {
	int	ie_error;	/* error value to be set in M_IOCACK */
	int	ie_rval;	/* return value to be set in M_IOCACK */
	char	* ie_buf;	/* buffer address for transparent ioctls */
	int	ie_len;		/* buffer length for transparent ioctls */
} iecho_t;

typedef	struct echo_blk {
	unsigned int	eb_len;		/* mp->b_wptr = mp->b_rptr + eb_len */
	unsigned short	eb_flag;	/* mp-> b_flag */
	unsigned char	eb_type;	/* mp->b_datap->db_type */
	unsigned char	eb_band;	/* mp->b_band */
} eblk_t;

typedef	struct eqvals {
	long	eq_minpsz;
	long	eq_maxpsz;
	long	eq_lowat;
	long	eq_hiwat;
	struct {
	unsigned int	eqf_minpsz:1;
	unsigned int	eqf_maxpsz:1;
	unsigned int	eqf_lowat:1;
	unsigned int	eqf_hiwat:1;
	}	eq_flags;	/* which fields to set */
} eqvals_t;

#if ((CPU_FAMILY==I960) && (defined __GNUC__))
#pragma align 0                 /* turn off alignment requirement */
#endif  /* CPU_FAMILY==I960 */

#define ef_minpsz	eq_flags.eqf_minpsz
#define ef_maxpsz	eq_flags.eqf_maxpsz
#define ef_lowat	eq_flags.eqf_lowat
#define ef_hiwat	eq_flags.eqf_hiwat

#endif	/* _MIECHO_ */

#endif /* __INCmiechoh */
