/** Copyright (c) 1993  Mentat Inc.
 ** mikernel.h 4.8, last change 5/10/94
 **/

#ifndef _MIKERNEL_
#define _MIKERNEL_
#ifndef WRS
#ifndef lint
static char	mikernel_h_sccsid[] = "@(#)mikernel.h	4.8";
#endif /* WRS */
#endif

/*
 * All likely combinations of KERNEL...
 */
#define KERNEL		1
#define _KERNEL_	1
#define _KERNEL		1
#define KERNEL_		1

#include <types.h>
#ifdef WRS
#include <led.h>	/* Mentat port-specific definitions */
#include <streams/stream.h>	/* Required for all Mentat STREAMS code */
#else
#include <stream.h>	/* Required for all Mentat STREAMS code */
#include <led.h>	/* Mentat port-specific definitions */
#endif /* WRS */
#include <micommon.h>	/* Mentat common definitions */

typedef	struct msgb	* MBLKP;
typedef	struct msgb	** MBLKPP;

#include <miutil.h>	/* Functions used by all Mentat STREAMS code */
#include <milocks.h>	/* Lock definitions (possibly overriden in led.h) */
/*
 * Streams q_info structures used by Mentat Modules
 *			idnum	idname		minpsz	maxpsz	hiwat	lowat
 *
 * MPS Components
 */
#define MPSID_STH	{ 5000,	MI_STH_NAME, 	0,	INFPSZ,	4096,	2048 }
#define MPSID_MIWELD	{ 5010,	MI_WELD_NAME,	0,	INFPSZ,	2048,	 128 }

/*
 * Mentat Modules
 */
#define	MPSID_CLONE	{ 5200,	MI_CLONE_NAME,	0,	INFPSZ,	2048,  128 }
#define	MPSID_DRVE	{ 5202,	MI_DRVE_NAME,	0,	INFPSZ,	2048,  128 }
#define MPSID_ECHO	{ 5204,	MI_ECHO_NAME,	0,	INFPSZ,	2048,  128 }
#define MPSID_LOG	{ 5206,	MI_LOG_NAME,	0,	INFPSZ,	2048,  128 }
#define	MPSID_MODE	{ 5208,	MI_MODE_NAME,	0,	INFPSZ,	2048,  128 }
#define MPSID_MUX	{ 5210,	MI_MUX_NAME, 	0,	INFPSZ,	1024,  128 }
#define MPSID_NULS	{ 5212,	MI_NULS_NAME,	0,	INFPSZ,	 512,  128 }
#define MPSID_NULZ	{ 5214,	MI_NULZ_NAME,	0,	INFPSZ,	 512,  128 }
#define MPSID_PASS	{ 5216,	MI_PASS_NAME, 	0,	INFPSZ,	2048,  128 }
#define MPSID_PIPEMOD	{ 5218,	MI_PIPEMOD_NAME,0,	INFPSZ,	2048,  128 }
#define MPSID_SC	{ 5220,	MI_SC_NAME, 	0,	INFPSZ,	2048,  128 }
#define MPSID_SAD	{ 5222,	MI_SAD_NAME, 	0,	INFPSZ,	4096, 2048 }
#define MPSID_SPASS	{ 5224,	MI_SPASS_NAME, 	0,	INFPSZ,	2048,  128 }
#define MPSID_TIMOD	{ 5226,	MI_TIMOD_NAME, 	0,	INFPSZ,	2048,  128 }
#define MPSID_NTIRDWR	{ 5228,	MI_NTIRDWR_NAME,0,	INFPSZ,	2048,  128 }
#define MPSID_TIRDWR	{ 5230,	MI_TIRDWR_NAME,	0,	INFPSZ,	2048,  128 }
#define MPSID_TMOD	{ 5232,	MI_TMOD_NAME, 	0,	INFPSZ,	2048,  128 }
#define MPSID_TMUX	{ 5234,	MI_TMUX_NAME, 	0,	INFPSZ,	 512,  128 }
#define MPSID_TPIT	{ 5236,	MI_TPIT_NAME, 	0,	INFPSZ,	 512,  128 }
#define MPSID_DISD	{ 5238,	MI_DMODD_NAME,	0,	INFPSZ,	2048,  128 }
#define MPSID_DIST	{ 5240,	MI_DMODT_NAME,	0,	INFPSZ,	2048,  128 }
#define MPSID_DN	{ 5242,	MI_DN_NAME, 	0,	1500,	 512,  128 }
#define MPSID_DNF	{ 5244,	MI_DNF_NAME, 	0,	4352,	 512,  128 }
#define	MPSID_DLB	{ 5246, MI_DLB_NAME,	0,	1500,	 512,  128 }
#define	MPSID_HAVOC	{ 5248, MI_HAVOC_NAME,	0,	INFPSZ,	 127,   16 }
#define	MPSID_HAVOCM	{ 5250, MI_HAVOCM_NAME,	0,	INFPSZ,	 127,   16 }
#define	MPSID_DLSM8013	{ 5260, MI_DLSM8013_NAME, 0,	1500,	   0,	 0 }
#define	MPSID_DLSM_NPE	{ 5262, MI_DLSM_NPE_NAME, 0,	4480,	   0,	 0 }


/*
 * Mentat TCP
 */
#define MPSID_ARP	{ 5305, MI_ARP_NAME,	0,	INFPSZ,	 512,	128 }
#define MPSID_ARPM	{ 5306, MI_ARPM_NAME,	0,	INFPSZ,	 512,	128 }
#define MPSID_RAWIP	{ 5310, MI_RAWIP_NAME,	1,	INFPSZ,	 512,	128 }
#define MPSID_RAWIPM	{ 5311, MI_RAWIPM_NAME,	1,	INFPSZ,	 512,	128 }
#define MPSID_IP	{ 5315, MI_IP_NAME,	1,	INFPSZ, MAX_ULONG, 128 }
#define MPSID_IPM	{ 5316, MI_IPM_NAME,	1,	INFPSZ, MAX_ULONG, 128 }
#define	MPSID_RTCP	{ 5320, MI_TCP_NAME,	0,	INFPSZ, TCP_RECV_HIWATER \
							, TCP_RECV_LOWATER }
#define	MPSID_WTCP	{ 5320, MI_TCP_NAME,	0,	INFPSZ,	 127,	 16 }
#define	MPSID_RTCPM	{ 5321, MI_TCPM_NAME,	0,	INFPSZ, TCP_RECV_HIWATER, TCP_RECV_LOWATER }
#define	MPSID_WTCPM	{ 5321, MI_TCPM_NAME,	0,	INFPSZ,	 127,	 16 }
#define MPSID_UDP	{ 5325, MI_UDP_NAME,	0,	65535,	 512,	128 }
#define MPSID_UDPM	{ 5326, MI_UDPM_NAME,	0,	65535,	 512,	128 }
#define	MPSID_AFU	{ 5330, MI_AFU_NAME,	0,	MAX_MB,	MAX_MB,	512 }
#define	MPSID_SOCKMOD	{ 5335, MI_SOCKMOD_NAME, MINPSZ_ERROR, MAXPSZ_ERROR	\
							, FLOODSIZE-1, 1 }

/*
 * Mentat XTP
 */
#define	MPSID_XT	{ 5405,	MI_XT_NAME,	0,	INFPSZ,	127,	16 }
#define	MPSID_XTM	{ 5410,	MI_XTM_NAME,	0,	INFPSZ,	127,	16 }
 
/*
 * Mentat XNS
 */
#define XNSID_ENXR	{ 5105, MI_ENXR_NAME,	0,	INFPSZ,	   2048,	128 }
#define XNSID_XDG	{ 5110, MI_XDG_NAME,	0,	INFPSZ,	    512,	128 }
#define XNSID_XECHO	{ 5115, MI_XECHO_NAME,	0,	INFPSZ,	    512,	128 }
#define XNSID_XF	{ 5120, MI_XF_NAME,	0,	INFPSZ,	    512,	128 }
#define XNSID_XPE	{ 5125, MI_XPE_NAME,	0,	INFPSZ,	    512,	128 }
#define XNSID_XS	{ 5130, MI_XS_NAME,	0,	INFPSZ,	(2*8192),	128 }
#define XNSID_TRXR	{ 5135, MI_TRXR_NAME,	0,	INFPSZ,	   2048,	128 }
#define	XNSID_TRSR	{ 5140,	MI_TRSR_NAME,	0,	INFPSZ,	   2048,	128 }
#define XNSID_IPX	{ 5145, MI_IPX_NAME,	0,	INFPSZ,	    512,	128 }
#define XNSID_NPEP	{ 5150, MI_NPEP_NAME,	0,	INFPSZ,	    512,	128 }
#define XNSID_SPX	{ 5155, MI_SPX_NAME,	0,	INFPSZ,	(2*8192),	128 }
#define XNSID_XFXNS	{ 5160, MI_XFXNS_NAME,	0,	INFPSZ,	    512,	128 }
#define XNSID_XFIPX	{ 5165, MI_XFIPX_NAME,	0,	INFPSZ,	    512,	128 }

#ifdef MPS
/*
 * MPS configuration variables defined in port-specific minit.c
 * from #defines of same name, e.g., STRMSGSZ for mps_g_strmsgsz.
 */
globalref	unsigned long	mps_g_strmsgsz;
globalref	unsigned long	mps_g_strctlsz;
#ifndef __MPSALLOC__
globalref	unsigned long	mps_g_max_fast_mblk;
#endif

#define	mi_adjmsg	adjmsg

#endif /* MPS */

#endif /*   _MIKERNEL_  */
