/* sysmacros.h - Vxworks Streams header */

/* Copyright 1984-1995 Wind River Systems, Inc. */

/*
modification history
--------------------
01a,23aug95,jag  moved all the macros to  sysmacros.h.
*/

/** Copyright (c) 1993-1994  Mentat Inc.
 ** misysmac.h 4.3, last change 6/3/94
 **/

#ifndef _MISYSMAC_
#define _MISYSMAC_

#ifndef WRS
static char	misysmac_h_sccsid[] = "@(#)misysmac.h	4.3";
#endif

/* 
 * A little lecture on sysmacros.h ...
 *
 * The Streams Programmers Guide says that there has to be a header file
 * called "sysmacros.h".  Unfortunately, that name is one character too
 * long for some systems, such as OS/2.  References to "sysmacros.h"
 * from MPS files are changed to "misysmac.h".  On systems that normally
 * have a "sysmacros.h", this file will redirect attention to the native
 * header.  On systems that do not have a native "sysmacros.h", but do
 * allow a name that long, there will be an MPS header file with that
 * name in the port-specific header directory.  
 *
 * In addition SVR4 DDI/DKI spec claims that ddi.h should be used in place
 * of sysmacros.h.  Here too there are problems.  On ESIX SVR4, for example,
 * ddi.h redefines some streams.h definitions.
 *
 * The default here is to define those macros we need for MPS and protocol
 * modules.  Changes and/or port-specific includes may be added as needed.
 */

#include "sysmacros.h"

#endif	/* _MISYSMAC_	*/
