/** Copyright (c) 1993  Mentat Inc.
 ** miverify.h 4.3, last change 4/14/94
 **/


#ifndef _MIVERIFY_
#define _MIVERIFY_
#ifndef WRS
#ifdef lint
static char	miverify_h_sccsid[] = "@(#)miverify.h	4.3";
#endif
#endif



/*
 * miverify.h -
 *	LAST include file in all MPS source code.  Contains assertions about
 *	required defines, plus missing defines or overrides needed for a 
 *	particular port.
 */

/***********  General Fixups  *************/

#if defined(M_DATA) || defined(I_PUSH)
/*
 * Following are frequently neeeded for streams buffers, but not always
 * available.  So define here.  DEFxxx defined in led.h
 */
#ifndef STRCTLSZ
#define STRCTLSZ	DEF_STRCTLSZ
#endif
#ifndef STRMSGSZ
#define STRMSGSZ	DEF_STRMSGSZ
#endif

#endif

/*
 * replace INTERNAL_ONDELAY with NATIVE_ONDELAY, which
 * reverses sense of ifdef's.
 */
#ifdef NATIVE_ONDELAY
#undef INTERNAL_ONDELAY
#else
#define INTERNAL_ONDELAY
#endif
/*
 ** T_OPTMGMT_REQ definition in xti.h but not in SVR4 tiuser.h
 *  Don't know what's best for this
 */
#ifndef T_CURRENT
#define T_CURRENT	MI_T_CURRENT
#endif


/***********  General Assertions  **********/

#ifndef	MI_BIG_ENDIAN
#ifndef	MI_LITTLE_ENDIAN
#error Exactly one of MI_BIG_ENDIAN or MI_LITTLE_ENDIAN must be defined.
#endif
#endif

#ifdef	MI_BIG_ENDIAN
#ifdef	MI_LITTLE_ENDIAN
#error Exactly one of MI_BIG_ENDIAN or MI_LITTLE_ENDIAN must be defined.
#endif
#endif


#ifdef KERNEL

/***********  Kernel Fixups  *************/

/*
 * prototypes missing from at least one system's header files...
 */
extern	int	(* getadmin( ushort mid ))(   void   );
extern	ushort	getmid(   char * name   );


/***********  Kernel Assertions  **********/
#ifdef SVR4_STYLE
#ifdef SVR3_STYLE
#error Exactly one of SVR4_STYLE and SVR3_STYLE must be defined
#endif
#endif
#ifndef SVR4_STYLE
#ifndef SVR3_STYLE
#error Exactly one of SVR4_STYLE and SVR3_STYLE must be defined
#endif
#endif

#ifdef MPS

/*
 * With MPS we had better be sure our stream.h & stropts.h are being used.
 */
#ifdef I_PUSH
#ifndef _MPS_STROPTS_
#error MPS requires MPS version of stropts.h
#endif
#endif

#ifdef M_DATA
#ifndef _MPS_STREAM_
#error MPS requires use of MPS version of stream.h
#endif
#endif

/*
 * With MPS and our poll() we had better be sure our poll.h is being used.
 * and that int_fd has been defined to be the proper field within struct
 * pollfd.
 */
#ifndef NATIVE_POLL
#ifdef POLLIN
#ifndef _MIPOLL_
#error MPS requires MPS version of poll.h when OS has no native poll()
#endif
#ifndef int_fd
#error MPS sth_poll requires int_fd to be defined per struct pollfd fields
#endif
#endif	/* POLLIN	*/
#endif	/* NATIVE_POLL	*/

#endif		/* ifdef MPS	*/


#else	/* not KERNEL */

/***********  User Fixups *************/


/***********  User Assertions  **********/

#endif		/* ifdef/else KERNEL */

#endif		/* ifdef _MIVERIFY_ */

