/** Copyright (c) 1989-1994  Mentat Inc.
 ** osr.h 4.18, last change 10/4/94
 **/

/* Copyright 1994-1995 Wind River Systems, Inc. */
#include "copyright_wrs.h"

/*   
modification history
--------------------
01a,18sep95,sgv  Removed OSRQ_INSERT for I960 and made it into a routine.
*/

#ifndef __INCosrh
#define __INCosrh

#ifndef _OSR_
#define _OSR_

#ifndef WRS
#ifndef lint
static	char	osr_h_sccsid[] = "@(#)osr.h	4.18";
#endif
#endif /* WRS */

/* All stream head OSR routines are called out of sth_osr_handoff, for initial processing, or sth_osr_loop, for restarted
 * OSRs.  They take just an OSR as an argument, and return OSR_DONE, if the OSR processing is done, or OSR_WAITING if not.
 */
typedef	boolean		OSR_STATUS;
#define	OSR_DONE	true
#define	OSR_WAITING	false

#if ((CPU_FAMILY==I960) && (defined __GNUC__))
#pragma align 1                 /* tell gcc960 not to optimize alignments */
#endif  /* CPU_FAMILY==I960 */

typedef	struct osr_ioc_arg_s {
	char	* oia_ubuf;
	union {
		int	oia_arg_iocu;
		FDCELL	oia_argfd_iocu;
		char	* oia_argp_iocu;
		u32	* oia_argup_iocu;
	} iocu;
	int	oia_len;
#ifdef OIA_XTRA
	OIA_XTRA		/* Implementation-dependent extra stuff */
#endif
} OIA, * OIAP;

#define	oia_arg			iocu.oia_arg_iocu
#define	oia_fd			iocu.oia_argfd_iocu
#define	oia_argp		iocu.oia_argp_iocu
#define	oia_argup		iocu.oia_argup_iocu

typedef struct ioctl_osr_s {
	int	ioc_cmd;
	MBLKP	ioc_mp1;
	OIA	ioc_oia[3];
	cred_t	ioc_creds;
	unsigned int ioc_flags;
	struct sth_s * ioc_poll_sth;	/* More state for poll */
#ifdef IOCTL_XTRA
	IOCTL_XTRA		/* Implementation-dependent extra stuff */
#endif
} IOCTL_OSR;

#define	osr_ioctl_cmd		osr_osru.ioctl_osr.ioc_cmd
#define	osr_ioctl_creds		osr_osru.ioctl_osr.ioc_creds
#define	osr_ioctl_mp1		osr_osru.ioctl_osr.ioc_mp1
#define	osr_ioctl_flags		osr_osru.ioctl_osr.ioc_flags
#define	osr_ioctl_ubuf0		osr_osru.ioctl_osr.ioc_oia[0].oia_ubuf
#define	osr_ioctl_arg0		osr_osru.ioctl_osr.ioc_oia[0].oia_arg
#define	osr_ioctl_fd0		osr_osru.ioctl_osr.ioc_oia[0].oia_fd
#define	osr_ioctl_arg0p		osr_osru.ioctl_osr.ioc_oia[0].oia_argp
#define	osr_ioctl_arg0up	osr_osru.ioctl_osr.ioc_oia[0].oia_argup
#define	osr_ioctl_arg0_len	osr_osru.ioctl_osr.ioc_oia[0].oia_len
#define	osr_ioctl_ubuf1		osr_osru.ioctl_osr.ioc_oia[1].oia_ubuf
#define	osr_ioctl_arg1		osr_osru.ioctl_osr.ioc_oia[1].oia_arg
#define	osr_ioctl_fd1		osr_osru.ioctl_osr.ioc_oia[1].oia_fd
#define	osr_ioctl_arg1p		osr_osru.ioctl_osr.ioc_oia[1].oia_argp
#define	osr_ioctl_arg1up	osr_osru.ioctl_osr.ioc_oia[1].oia_argup
#define	osr_ioctl_arg1_len	osr_osru.ioctl_osr.ioc_oia[1].oia_len
#define	osr_ioctl_ubuf2		osr_osru.ioctl_osr.ioc_oia[2].oia_ubuf
#define	osr_ioctl_arg2		osr_osru.ioctl_osr.ioc_oia[2].oia_arg
#define	osr_ioctl_fd2		osr_osru.ioctl_osr.ioc_oia[2].oia_fd
#define	osr_ioctl_arg2p		osr_osru.ioctl_osr.ioc_oia[2].oia_argp
#define	osr_ioctl_arg2up	osr_osru.ioctl_osr.ioc_oia[2].oia_argup
#define	osr_ioctl_arg2_len	osr_osru.ioctl_osr.ioc_oia[2].oia_len
#define	osr_poll_sth		osr_osru.ioctl_osr.ioc_poll_sth

typedef struct close_osr_s {
	IOCTL_OSR	close_ioctl_osr; /* for sth_ipop processing during sth_osr_close */
	uint	close_flags;
	SQHP	close_sqh; dev_t	close_dev;
	int	close_saved_pmux_top;
#ifdef CLOSE_XTRA
	CLOSE_XTRA		/* Implementation-dependent extra stuff */
#endif
} CLOSE_OSR;
#define	osr_close_flags		osr_osru.close_osr.close_flags
#define	osr_close_creds		osr_osru.close_osr.close_ioctl_osr.ioc_creds
#define	osr_close_sqh		osr_osru.close_osr.close_sqh
#define	osr_close_dev		osr_osru.close_osr.close_dev
#define	osr_close_saved_pmux_top osr_osru.close_osr.close_saved_pmux_top
#define	osr_close_ubuf0		\
		osr_osru.close_osr.close_ioctl_osr.ioc_oia[0].oia_ubuf
#define	osr_close_wait_time	\
		osr_osru.close_osr.close_ioctl_osr.ioc_oia[2].oia_arg

typedef struct open_osr_s {
	cred_t	open_creds;
	int	open_dindex;
	dev_t	open_dev;
	dev_t	open_new_dev;
	uint	open_sflag;
	uint	open_flags;
	queue_t	* open_q;
	char	* open_name;
	struct strapush	* open_stra;
	int	open_npush;
	SQHP	open_sqh;
	SQHP	open_clone_sqh;
#ifdef OPEN_XTRA
	OPEN_XTRA		/* Implementation-dependent extra stuff */
#endif
} OPEN_OSR;
#define	osr_open_creds		osr_osru.open_osr.open_creds
#define	osr_open_dindex		osr_osru.open_osr.open_dindex
#define	osr_open_dev		osr_osru.open_osr.open_dev
#define	osr_open_new_dev	osr_osru.open_osr.open_new_dev
#define	osr_open_sflag		osr_osru.open_osr.open_sflag
#define	osr_open_flags		osr_osru.open_osr.open_flags
#define	osr_open_q		osr_osru.open_osr.open_q
#define	osr_open_name		osr_osru.open_osr.open_name
#define	osr_open_stra		osr_osru.open_osr.open_stra
#define	osr_open_npush		osr_osru.open_osr.open_npush
#define	osr_open_sqh		osr_osru.open_osr.open_sqh
#define	osr_open_clone_sqh	osr_osru.open_osr.open_clone_sqh

typedef struct rw_osr_s {
	int	rw_total;
	uint	rw_flags;
	OIA	rw_oia;
	char	* rw_orig_base;
	int	rw_orig_count;
#ifdef RD_XTRA
	RD_XTRA			/* Implementation-dependent extra stuff */
#endif
} RD_OSR;
#define	F_OSR_RW_MREAD_SENT	0x1

#define	osr_rw_total	osr_osru.rw_osr.rw_total
#define	osr_rw_flags	osr_osru.rw_osr.rw_flags
#define	osr_rw_base	osr_osru.rw_osr.rw_oia.oia_argp
#define	osr_rw_count	osr_osru.rw_osr.rw_oia.oia_len
#define	osr_rw_orig_base osr_osru.rw_osr.rw_orig_base
#define	osr_rw_orig_count osr_osru.rw_osr.rw_orig_count

/* Device and module load and unload operations. */
typedef struct install_osr_s {
	char	* install_name;		/* Name of module to be installed. */
	struct streamtab * install_str;	/* Streamtab pointer. */
	int	install_flags;		/* F_MODSW_OLD_OPEN | F_MODSW_IS_DEVICE */
	int	install_sqlvl;		/* Synchronization level. */
	struct streamtab * install_buddy; /* Shared writer list buddy. */
	int	install_cookie;		/* Usually the device major number. */
	cred_t	install_creds;
} INSTALL_OSR;

#define	osr_install_name	osr_osru.install_osr.install_name
#define	osr_install_str		osr_osru.install_osr.install_str
#define	osr_install_flags	osr_osru.install_osr.install_flags
#define	osr_install_sqlvl	osr_osru.install_osr.install_sqlvl
#define	osr_install_buddy	osr_osru.install_osr.install_buddy
#define	osr_install_cookie	osr_osru.install_osr.install_cookie
#define	osr_install_creds	osr_osru.install_osr.install_creds

/* overload some OSR fields for poll() */
#define	osr_poll_index		osr_ioctl_arg1_len
#define	osr_poll_nfds		osr_ioctl_arg2_len
#define	osr_poll_timer_mp	osr_ioctl_mp1

#define	OSR_POLLFD(osr)	(&(((struct pollfd *)(osr)->osr_ioctl_arg1p)[(osr)->osr_poll_index]))
#define	OSR_POLLS(osr)	(&(((POLLS *)(osr)->osr_ioctl_arg2p)[(osr)->osr_poll_index]))

typedef	struct osrq_s {
	struct osrq_s * osrq_next;
	struct osrq_s * osrq_prev;
	struct osrq_s * osrq_osrqp;	/* Pointer to OSR queue on which this OSR was enqueued. */
	struct osr_s  * osrq_osr;
} OSRQ, * OSRQP;
#define	osr_osrqp	osr_osrq.osrq_osrqp

#ifdef	KERNEL
typedef	struct slp_s {
	struct slp_s * slp_next;
	struct slp_s ** slp_ptpn;
	struct osr_s * slp_osr;
	u32	slp_cookie;
	SQHP	slp_sqh_arr[5];
	SQHPP	slp_sqh_next;
	int	slp_err;
#ifdef	SLP_XTRA
	SLP_XTRA
#endif
} SLP, * SLPP, ** SLPPP;

typedef struct osr_s {
	/* The osr_sq must be quadword aligned! */
	SQE	osr_sqe;
	OSRQ	osr_osrq;

	struct	sth_s	* osr_sth;
	OSR_STATUS	(*osr_callback)(struct osr_s *);
	pid_t	osr_pid;

/* OSR init routine will zero out from osr_zero_begin up to osr_zero_end + call specific union element */
#define	osr_zero_begin	osr_ret_val

	int	osr_ret_val;
	int	osr_err;
	u16	osr_flags;
	u8	osr_state;	/* Outer OSR mini state machine */
	u8	osr_istate;	/* Inner OSR mini state machine */
	int	osr_bufcall_id;	/* Outstanding bufcall */
	SLPP	osr_slp;

#ifdef OSR_XTRA
	OSR_XTRA		/* Implementation-dependent extra stuff */
#endif

#define	osr_zero_end	osr_osru

	union {
		IOCTL_OSR	ioctl_osr;
		OPEN_OSR	open_osr;
		RD_OSR		rw_osr;
		INSTALL_OSR	install_osr;
		CLOSE_OSR	close_osr;
	} osr_osru;
#ifdef OSR_NONZERO_XTRA
	OSR_NONZERO_XTRA
#endif
} OSR, * OSRP, ** OSRPP;

#if ((CPU_FAMILY==I960) && (defined __GNUC__))
#pragma align 0                 /* turn off alignment requirement */
#endif  /* CPU_FAMILY==I960 */

/* OSR flags that are referenced by the common Stream head code */
#define	F_OSR_UNINTERRUPTIBLE	0x0001	/* don't interrupt operation */
#define	F_OSR_POLL_HIT		0x0002	/* A poll event for this osr has occurred */
#define	F_OSR_ONDELAY		0x0008	/* O_NDELAY request */
#define	F_OSR_NONBLOCK		0x0010	/* O_NONBLOCK request */
#define	F_OSR_IOCTL_ALLOC_ONLY	0x0020	/* Allocate only (no copyin) */

/* OSR flags that are commonly needed by port-specific code */
#define	F_OSR_WAITING		0x0040	/* someone is waiting for this request to finish */
#define	F_OSR_FINISHED		0x0080	/* this request is done */
#define	F_OSR_SYSSPACE		0x0100	/* request from inside "kernel" */
#define	F_OSR_COPYIN		0x0200
#define	F_OSR_COPYOUT		0x0400

/* OSR flags available for port-specific use */
#define	F_OSR_PORTFLAG_6	0x0004
#define	F_OSR_PORTFLAG_5	0x0800
#define	F_OSR_PORTFLAG_4	0x1000
#define	F_OSR_PORTFLAG_3	0x2000
#define	F_OSR_PORTFLAG_2	0x4000
#define	F_OSR_PORTFLAG_1	0x8000
#define	F_OSR_PORTFLAGS		(F_OSR_PORTFLAG_1|F_OSR_PORTFLAG_2| \
				F_OSR_PORTFLAG_3|F_OSR_PORTFLAG_4| \
				F_OSR_PORTFLAG_5|F_OSR_PORTFLAG_6)

#define	OSRQ_NEXT(osrq)		((osrq)->osrq_next)
#define	OSRQ_PREV(osrq)		((osrq)->osrq_prev)
#define	OSRQ_EMPTY(osrq)	((osrq)->osrq_next == (osrq))
#define	OSR_REMOVE(osr)							\
	((osr)->osr_osrq.osrq_next->osrq_prev = (osr)->osr_osrq.osrq_prev, \
	(osr)->osr_osrq.osrq_prev->osrq_next = (osr)->osr_osrq.osrq_next,  \
	(osr)->osr_osrqp = nilp(OSRQ))

/*
 * The OSRQ_INSERT macro has been modified and made into a routine for I960 
 * as the I960 optimising compiler was NOT executing the assignment of 
 * osrq->osrq_prev->osrq_next. Hence we add a dummy variable which is set to 
 * the value of osrq->osrq_prev->osrq_next, This way we force the compiler to 
 * execute a prior statement that is we are forcing the assignment of 
 * osrq->osrq_prev->osrq_next
 */

#if (CPU_FAMILY != I960)
#define	OSRQ_INSERT(osrq, osr)				\
	(((osr)->osr_osrq.osrq_next = (osrq),		\
	(osr)->osr_osrq.osrq_prev = (osrq)->osrq_prev,	\
	(osr)->osr_osrq.osrq_osr = (osr),		\
	(osr)->osr_osrqp = (osrq),			\
	(osrq)->osrq_prev->osrq_next = &(osr)->osr_osrq,\
	(osrq)->osrq_prev = &(osr)->osr_osrq),		\
	(osrq)->osrq_next == &(osr)->osr_osrq)
#else  
extern OSRQ_INSERT(OSRQP osrq, OSRP osr);
#endif /* CPU_FAMILY != I960 */

#define	OSR_SQE_CALLBACK_INIT(osr, osr_cb, sqe_cb)	\
	(osr)->osr_callback = (osr_cb),			\
	(osr)->osr_sqe.sqe_callback = (sqe_cb),		\
	(osr)->osr_sqe.sqe_arg0 = (PCELL)(osr),		\
	(osr)->osr_sqe.sqe_arg1_mp = nilp(mblk_t)


#endif	/*KERNEL*/

#endif

#endif /* __INCosrh */
