/* poll.h - streams poll header */

/* Copyright 1984-1995 Wind River Systems, Inc. */

/*
modification history
--------------------
01a,24aug95,sgv  Added copyright
*/


#ifndef __INCpollh
#define __INCpollh

/** Copyright (c) 1993  Mentat Inc.
 ** poll.h 4.1, last change 8/31/93
 **/

#ifndef _POLL_
#define _POLL_

#ifdef __cplusplus
extern "C" {
#endif

#ifndef WRS
static char	poll_h_sccsid[] = "@(#)poll.h	4.1";
#endif /* WRS */

/*
 * If system supports a poll() system call and poll.h exists, then this
 * file MUST NOT be used.  Use this version of poll.h only if
 * NATIVE_POLL is not defined (poll done by MPS sth_poll).  Note: on
 * some systems with poll() system call, there may be now poll.h;
 * in that case, supply a version of poll.h which includes the file(s)
 * necessary to obtain the structures/definitions in this file.
 */
#define _MIPOLL_		/* Use by miverify.h for assertion checking */

#define	NPOLLFILE	20

/* Poll masks */
#define	POLLIN		0x001	/* A non-priority message is available */
#define	POLLPRI		0x002	/* A high priority message is available */
#define	POLLOUT		0x004	/* The stream is writable for non-priority messages */
#define	POLLERR		0x008	/* A error message has arrived */
#define	POLLHUP		0x010	/* A hangup has occurred */
#define	POLLNVAL	0x020	/* This fd is bogus */
#define	POLLRDNORM	0x040	/* A non-priority message is available */
#define	POLLRDBAND	0x080	/* A priority message (band > 0) message is available */
#define	POLLWRNORM	0x100	/* Same as POLLOUT */
#define	POLLWRBAND	0x200	/* A priority band exists and is writable */
#define	POLLMSG		0x400	/* A signal message has reached the front of the queue */

#if ((CPU_FAMILY==I960) && (defined __GNUC__))
#pragma align 1                 /* tell gcc960 not to optimize alignments */
#endif  /* CPU_FAMILY==I960 */

/* array of streams to poll */
struct pollfd {
	int	fd;
	short	events;
	short	revents;
	int	_ifd;		/* Internal "fd" for the benefit of the kernel */
};

/* I_POLL structure for ioctl on non-5.3 systems */
struct strpoll {
	unsigned long	nfds;
	struct pollfd	* pollfdp;
	int		timeout;
};

#if ((CPU_FAMILY==I960) && (defined __GNUC__))
#pragma align 0                 /* turn off alignment requirement */
#endif  /* CPU_FAMILY==I960 */

#ifdef __cplusplus
}
#endif

#endif	/* _POLL_ */

#endif /* __INCpollh */
